; Dead thing characters

optMonstersHeal         equ true                        ; Yes, they can use magic to heal

deadMon_Steamed         equ $DB                         ;
deadMon_Sword           equ $DE                         ;
deadMon_Arrow           equ $DF                         ;
deadMon_Steaming        equ $E0                         ;

JokeDelay               equ 20                          ; How long we wait

DodgeTime               equ 8                           ; Time before projectiles hurt their firer
ManDodgeTime            equ 12                          ;

MaxMagic                equ 255                         ;
MaxWounds               equ 127                         ;

        struct                                          ;
stStatus                ds 1                            ;
stMaze                  ds 1                            ;
        send                                            ;

; A few QAD macros

mAddNoise               macro(cnt)                      ;
                          ld a,(NoiseCnt)               ;
                          add a,cnt                     ;
                          ld (NoiseCnt),a               ;
                          mend                          ;

mOutSound               macro(reg)                      ;
                          out ($FE),reg                 ;
                          mend                          ;

mNoiseON                macro()                         ;
                          ld a,(CType)                  ;
                          mOutSound(a)                  ;
                          mend                          ;

mNoiseOFF               macro()                         ;
                          ld a,%000 00 000              ;
                          mOutSound(a)                  ;
                          mend                          ;

; This code builds a random maze

                        include "maze.inc"              ;

; Start the game

StartGame               ld a,stStatus                   ; Show the status screen
                        ld (WhichScreen),a              ;

                        ld a,(GameMode)                 ; What kind of game?

                        cp IsRunning                    ; Running game
                        jr z StartARunningGame          ;

                        cp IsCremMode                   ; Crem mode
                        jr z StartACremModeGame         ;

                        ; Game with the settings...

                        ld a,(BType)                    ; The user's choice
                        ld (GameBType),a                ;

                        ld a,(AType)                    ; Masked maze setting
                        jr SG_SetA                      ; As below

                        ; Running game

StartARunningGame       ld a,%0000 0111                 ; Full-on aggression
                        ld (GameBType),a                ;

                        ld a,1                          ; Masked
                        jr SG_SetA                      ;

                        ; Crem mode

StartACremModeGame      ld a,%0000 0111                 ; Full-on aggression
                        ld (GameBType),a                ;

                        ld a,1                          ; Masked

                        ; Fall into...

SG_SetA                 ld (GameAType),a                ;

                        ld (Stack),sp                   ;

        if def bReturnInstantResult                     ;
                        ld hl,256                       ;
                        ld (nDTs),hl                    ;
                        ld a,8                          ;
                        ld (nRings),a                   ;

                        ld hl,10000                     ;
                        ld (GameScore),hl               ;

                        ld a,1                          ;

                        ret                             ;
        endif                                           ;

        if def bFixedMaze                               ;
                        ld hl,$1111                     ;
                        ld (Seed),hl                    ;
                        ld (Seed+2),hl                  ;
                        ld a,0                          ;
                        ld r,a                          ;
        endif                                           ;

                        ld sp,[Stack] 0                 ;

                        ; Add the silly message

                        call ShowTitleMsg               ; Add the title message

                        call RandRange                  ;

                        ld a,(LookAheadType)            ;
                        ld (AngleOffsetX),a             ;
                        neg                             ;
                        ld (AngleOffsetXNeg),a          ;
                        neg                             ;
                        sra a                           ;
                        ld (AngleOffsetY),a             ;
                        neg                             ;
                        ld (AngleOffsetYNeg),a          ;

                        ld a,0                          ; Init the progress showing
                        ld (ShowProgX),a                ;

                        call InitSanctuary              ;

                        call InitGame                   ;

                        call Gen8                       ;

                        ; Start us on the ground floor

                        ld a,0                          ;
                        ld (cFloor),a                   ;

                        call Recreate                   ;

                        call PlaceMon                   ;

                        call OpenBasement               ; If required

                        call ClearFloorZero             ; Clear it

;                        call JustifyT                   ;

                        call InitGameKeys               ;

                        ; We're starting on a new floor

                        call PlaceMan                   ; Place the man in the maze

                        call InitProjList               ;

                        ld a,0                          ; Clear the sword
                        ld (SwdPhase),a                 ;
                        ld hl,0                         ;
                        ld (SwdPos),hl                  ;

                        call FadeTileScreenFast         ;

                        ld a,stMaze                     ;
                        ld (WhichScreen),a              ;

                        call ClearTileScreen            ;
                        halt                            ;

                        call UnFadeTileScreenFast       ;

                        ; Set the speed

                        ld a,(GameBType)                ; Slow or fast?
                        ld b,5                          ;

                        and $01                         ;
                        jr z SetGameSpeed               ;

                        ld b,7                          ;
SetGameSpeed            ld a,b                          ;

                        ld (GameSpeed),a                ;
                        ld (GameLpCnt),a                ;

                        zeustimerstart 1                ;
GameLoop                call MoveMan                    ;

                        call MoveMonsters               ;

                        call MoveProjectiles            ;

;                        call GameScanKeys               ;

                        xor a                           ;
                        out ($FE),a                     ;

                        call JustifyScreen              ;

                        call DisplayStatus              ;

                        call Noises                     ;

                        call EditScreen                 ; Try editing

                        call Rand1                      ;
                        ld a,(Seed)                     ;
                        ld r,a                          ; Safe enough...

                        ; Speed

                        call CheckSpeed                 ;

                        call CheckJOKE                  ;
                        jp z DunIt                      ;

                        call CheckQuit                  ;
                        jp nz GameLoop                  ;

                        ; The player has been killed

LeaveGame               call FadeTileScreen             ;

                        ld de,0                         ; Treasure = 0
                        call CalcScore_NoTreasure       ;
                        ld (GameScore),hl               ; Save

                        ld sp,(Stack)                   ; Restore

                        ld a,0                          ; Flag that we were killed
                        ret                             ; Exit

; Check the speed

CheckSpeed              ld a,[GameLpCnt] 0              ;
                        dec a                           ;
                        ld (GameLpCnt),a                ;
                        ret nz                          ;

                        ld a,[GameSpeed] 0              ;
                        ld (GameLpCnt),a                ;

CheckSpeedPause         ld a,(IrqFlag)                  ;
                        or a                            ;
                        jr z CheckSpeedPause            ;

                        xor a                           ;
                        ld (IrqFlag),a                  ;

                        ret                             ;

; Clear the keys

InitGameKeys            ld hl,KeyStart                  ; Base
                        ld b,KeyEnd-KeyStart            ;

IGK                     ld (hl),0                       ;
                        inc hl                          ;
                        djnz IGK                        ;
                        ret                             ;
; Enable the jokes

PS_EnableJokes          ld a,$FF                        ; Set the enable flag
                        ld (bJokeEnable),a              ;
                        ret                             ; Done

; Enable the piss

PS_EnablePiss           ret                             ; Done

        if false                                        ;
                        ld hl,PissDefn                  ; Overwrite the chars
                        ld de,LightningDefn             ;
                        ld bc,16                        ;
                        ldir                            ;

                        ld a,$46                        ; Yellow
                        ld (LightningAttr1),a           ;
                        ld (LightningAttr2),a           ;
                        ret                             ; Done
        endif                                           ;

; We've escaped and finished the game

DunIt                   call FadeTileScreen             ;

                        call CalcScore_WithTreasure     ; We include the treasure
                        ld (GameScore),hl               ; Save

                        ; Exit this code

                        ld sp,(Stack)                   ; Restore

                        ld a,1                          ; Flag that we won
                        ret                             ; Exit

; Setup the game's variables

InitGame                xor a                           ;
                        out ($FE),a                     ;
                        ld (Wounds),a                   ;
                        ld (TreasureCount),a            ;
                        ld (UnderMan),a                 ;
                        ld (JFLAG),a                    ;

                        ld a,$FF                        ;
                        ld (pFrameX),a                  ;
                        ld (pFrameY),a                  ;

                        ld a,120                        ;
                        ld (CurrentMagic),a             ;

                        ld a,255                        ;
                        ld (ArrowCount),a               ;

                        ld a,3                          ;
                        ld (ArrDir),a                   ;
                        ld (ManAngle),a                 ;
                        ld (MManDelay),a                ; Conveniently fast first move
                        ld a,-8                         ;
                        ld (JustXDisp),a                ;

                        ld hl,BigMaze+14077             ;
                        ld (pMan),hl                    ;
                        ld (pManLookingSquare),hl       ;
                        call ConvBM_To_XY_HL            ;
                        ld (pFrameX),hl                 ;

                        call CalcDisplayTargetPos       ;

                        ld hl,[DispTargX16] 0           ;
                        ld (DispCurrX16),hl             ;
                        ld hl,[DispTargY16] 0           ;
                        ld (DispCurrY16),hl             ;

                        ret                             ;

; Fades

FadeTileScreen          ld iy,5                         ; Slow fade
                        jr FadeIt_IY                    ;

FadeTileScreenFast      ld iy,1                         ; Fast fade
                        jr FadeIt_IY                    ;

; Fade the palette

FadeIt_IY               ld hl,TilePalette               ; Copy it
                        ld de,VarPalette                ;
                        ld bc,32                        ;
                        ldir                            ;

                        ld c,9                          ;

FadeLp                  ld hl,VarPalette                ; Set the palette
                        call SetTilePaletteHL           ;

                        ; Reduce it

                        ld ix,VarPalette                ; Dec to zero
                        ld b,16                         ;
                        ld l,0                          ;

FadeLp2                 push bc                         ; Save

                        call GetRGB_IX                  ; RGB->D,E,C

                        ld a,d                          ;
                        call decnz                      ;
                        ld d,a                          ;

                        ld a,e                          ;
                        call decnz                      ;
                        ld e,a                          ;

                        ld a,c                          ;
                        call decnz                      ;
                        ld c,a                          ;

                        call SetRGB_IX                  ;

                        inc ix                          ;
                        inc ix                          ;

                        pop bc                          ; Loop
                        djnz FadeLp2                    ;

                        ; Done if zero

                        dec c                           ; Exit?
                        ret z                           ;

                        ; Delay

                        push iy                         ;
                        pop hl                          ;

FadeDelLp               halt                            ;

                        ld a,l                          ;
                        or a                            ;
                        jr z FadeLp                     ;

                        dec hl                          ;
                        jr FadeDelLp                    ;

; DECNZ A
decnz                   or a                            ;
                        ret z                           ;

                        dec a                           ;
                        ret                             ;

; Read a palette entry to RGB bytes D,E,C

GetRGB_IX               ld a,(ix)                       ; RGB in silly order
                        ld c,a                          ; RRRGGGBB

                        rra                             ; RRRGGGBB
                        rra                             ;
                        ld d,a                          ; xxRRRGGG

                        and %00 000 111                 ;
                        ld e,a                          ;

                        ld a,d                          ; xxRRRGGG

                        rra                             ;
                        rra                             ;
                        rra                             ;

                        and %00 000 111                 ;
                        ld d,a                          ;

                        ld a,(ix+1)                     ; xxxxxxxB
                        rra                             ; LSB in C
                        ld a,c                          ; RRRGGGBB
                        adc a,a                         ; RRGGGBB0
                        and %00 000 111                 ;
                        ld c,a                          ;

                        ret                             ; Done

; Save RGB
SetRGB_IX               ld a,d                          ; 00000RRR
                        add a,a                         ;
                        add a,a                         ;
                        add a,a                         ; 00RRR000
                        or e                            ; 00RRRGGG
                        add a,a                         ;
                        add a,a                         ; RRRGGG00
                        ld b,a                          ; save
                        ld a,c                          ; 00000BBB
                        srl a                           ;
                        or b                            ; RRRGGGBB
                        ld (ix),a                       ;

                        ld a,c                          ;
                        and %00000001                   ;
                        ld (ix+1),a                     ;

                        ret                             ;

UnFadeTileScreenFast    ld hl,TilePalette               ; Set the palette
                        call SetTilePaletteHL           ;
                        ret                             ;
; Edit the screen

EditScreen              ld a,(bJokeEnable)              ;
                        ld b,a                          ;
                        ld a,(Key2P)                    ;
                        and b                           ;
                        ret z                           ;

                        xor a                           ;
                        ld (Key2P),a                    ;

                        ; Edit it

                        ld hl,(pMan)                    ;
                        ld (pEdit),hl                   ;

                        ld a,(hl)                       ;
                        ld (EditUnder),a                ;

                        ld a,$90                        ;
                        ld (EditChar),a                 ;

                        call ShowEditCursor             ;

                        ; Edit loop

EditLp                  call EditDelay                  ; Scans keys

                        ; Move the cursor

                        call ClearEditCursor            ;

                        call GetCursorDir               ;
                        ld hl,[pEdit] 0                 ;
                        add hl,de                       ;
                        ld (pEdit),hl                   ;

                        call EditChangeChar             ;

                        call ShowEditCursor             ;

                        ; Change the character?

                        ld a,(KeyspP)                   ; Change it
                        or a                            ;
                        call nz EditReplace             ;

                        ; Delay

                        ld a,(Key2P)                    ;
                        or a                            ;
                        jr z EditLp                     ;

                        xor a                           ;
                        ld (Key2P),a                    ;

                        ; Clear the cursor

ClearEditCursor         ld hl,(pEdit)                   ; Restore the char
                        ld (hl),[EditUnder] 0           ;

                        ret                             ;

; Replace the char

EditReplace             ld a,[EditChar] 0               ;
                        ld (EditUnder),a                ;

                        xor a                           ;
                        ld (KeyspP),a                   ;

                        ret                             ;
; Move cursor?

GetCursorDir            call MMoveLR                    ; Move left or right?
                        jr c GCD_Set                    ; l or r, so can't move up/down

                        call MMoveUD                    ; Move up or down?

                        ld de,0                         ;
                        ret nc                          ; No

GCD_Set                 jp CDirect                      ; DE := offset

; Change char?

EditChangeChar          ld a,(KeyFire)                  ; Up?
                        or a                            ;
                        jr z ECC_1                      ; No

                        xor a                           ;
                        ld (KeyFireP),a                 ;

                        ld b,1                          ;
                        jr ECC_Change                   ;

ECC_1                   ld a,(KeyLight)                 ; Down?
                        or a                            ;
                        ret z                           ; No

                        xor a                           ;
                        ld (KeyLightP),a                ;

                        ld b,-1                         ;

                        ; Fall into

ECC_Change              ld a,(EditChar)                 ;
                        add a,b                         ;
                        ld (EditChar),a                 ;

                        ret                             ; Done

; Show the cursor

ShowEditCursor          ld hl,(pEdit)                   ; Save the char
                        ld a,(hl)                       ;
                        ld (EditUnder),a                ;

                        ld a,(EditChar)                 ;
                        ld (hl),a                       ;

                        ret                             ;

; Wait

EditDelay               ld bc,$300                      ;

ED_Lp                   push bc                         ;
                        call GameScanKeys               ;
                        pop bc                          ;

                        cpi                             ;
                        jp v ED_Lp                      ;
                        ret                             ;

; Should we make a noise

Noises                  ld a,[NoiseCnt] 0               ; Do we have any
                        or a                            ;
                        ret z                           ;

                        dec a                           ;
                        ld (NoiseCnt),a                 ;

                        ; Now, make a noise

                        ld a,(CType)                    ;
                        mOutSound(a)                    ;

                        ret                             ; Done

; Show the status screen

DisplayStatus           ld hl,Key1P                     ;
                        call ReadAKey                   ;
                        ret z                           ;

                        call FadeTileScreenFast         ;

                        ld a,stStatus                   ;
                        ld (WhichScreen),a              ;

                        call ClearTileScreen            ;

                        call UnFadeTileScreenFast       ;

                        call DrawScoreFixed             ;

DS_Lp                   equ *                           ; call GameScanKeys               ;

                        ld a,[TempStore] 0              ;
                        dec a                           ;
                        ld (TempStore),a                ;

                        and $07                         ;
                        call z SlowlyHeal               ;

                        call DrawScoreEtc               ;

                        call ArrowDir                   ;

                        ; Exit

                        ld hl,Key1P                     ;
                        call ReadAKey                   ;
                        jr z DS_Lp                      ;

                        xor a                           ;
                        ld (MManDelay),a                ;

                        call FadeTileScreenFast         ;

                        ld a,stMaze                     ;
                        ld (WhichScreen),a              ;

                        call ClearTileScreen            ;
                        halt                            ;

                        jp UnFadeTileScreenFast         ;

; Add the titles while we draw the maze

ShowTitleMsg            ld de,sNames1                   ;
                        ld hl,$0F00                     ;
                        call SPrint                     ;

                        ; Add something?

                        ld a,(GameCount)                ;
                        inc a                           ;
                        ld (GameCount),a                ;

                        ld de,sNames2                   ;
                        cp JokeDelay                    ;
                        jr z STM_1                      ;

                        ld de,sNames3                   ;
                        cp JokeDelay+1                  ;
                        jr z STM_1                      ;

                        ld de,sNames4                   ;
                        cp JokeDelay+2                  ;
                        jp nz ShowTitlesRev             ; Show the titles

STM_1                   ld hl,$1100                     ;
                        call SPrint                     ;

                        jp ShowTitlesRev                ; Show the titles

sNames1                 dbx *,"Please wait a moment...",0;
sNames2                 dbx *,"(while admiring those names)",0;
sNames3                 dbx *,"(you'll rarely see their like)",0;
sNames4                 dbx *,"(probably all dead by now)",0;

; Use the man movement keys to determine the arrow direction

ArrowDir                call MMoveLR                    ; Move left or right?
                        jr c AD_Set                     ; l or r, so can't move up/down

                        call MMoveUD                    ; Move up or down?
                        ret nc                          ; No

AD_Set                  ld (ArrDir),a                   ; Set the direction
                        ret                             ;

; Get the stored keys

MMoveLR                 ld bc,[LRKeys] 0                ;
                        push bc                         ;
                        pop af                          ;
                        ret                             ; Done

MMoveUD                 ld bc,[UDKeys] 0                ;
                        push bc                         ;
                        pop af                          ;
                        ret                             ; Done

; Test the man-move keys. CF = move

MMoveLR_Scan            in a,($1F)                      ; The Kemston joystick
                        and $03                         ; LR
                        dec a                           ; = %01
                        jr z MMR                        ;
                        dec a                           ; = %10
                        jr z MML                        ;

                        ld a,(DType)                    ; Use the alternate keys?
                        or a                            ;
                        jr nz MMoveLR_Alt               ;

                        ; Z/X

                        ld bc,zeuskeyaddr("ZX")         ;
                        in a,(c)                        ;

                        bit zeuskeybit("Z"),a           ;
                        jr z MMLR1                      ;

                        bit zeuskeybit("X"),a           ;
                        jr z MMLR2                      ;

MMLR0                   or a                            ;
                        ret                             ;

MMLR1                   bit zeuskeybit("X"),a           ;
                        jr z MMLR0                      ;

MML                     ld a,3                          ;
                        scf                             ;
                        ret                             ;

MMLR2                   bit zeuskeybit("Z"),a           ;
                        jr z MMLR0                      ;

MMR                     ld a,1                          ;
                        scf                             ;
                        ret                             ;

                        ; A/D

MMoveLR_Alt             ld bc,zeuskeyaddr("AD")         ;
                        in a,(c)                        ;

                        bit zeuskeybit("A"),a           ;
                        jr z MMLR_A1                    ;

                        bit zeuskeybit("D"),a           ;
                        jr z MMLR_A2                    ;

MMLR_A0                 or a                            ;
                        ret                             ;

MMLR_A1                 bit zeuskeybit("D"),a           ;
                        jr z MMLR_A0                    ;

                        ld a,3                          ;
                        scf                             ;
                        ret                             ;

MMLR_A2                 bit zeuskeybit("A"),a           ;
                        jr z MMLR_A0                    ;

                        ld a,1                          ;
                        scf                             ;
                        ret                             ;

MMoveUD_Scan            in a,($1F)                      ; The Kemston joystick
                        and $0C                         ; UDLR
                        cp $04                          ; = %0100
                        jr z MMD                        ;
                        cp $08                          ; = %1000
                        jr z MMU                        ;

                        ld a,(DType)                    ; Use the alternate keys?
                        or a                            ;
                        jr nz MMoveUD_Alt               ;

                        ld bc,zeuskeyaddr("NM")         ;
                        in a,(c)                        ;

                        bit zeuskeybit("N"),a           ;
                        jr z MMUD1                      ;

                        bit zeuskeybit("M"),a           ;
                        jr z MMUD2                      ;

                        or a                            ;
                        ret                             ;

MMUD1                   bit zeuskeybit("M"),a           ;
                        jr z MMLR0                      ;

MMU                     ld a,0                          ;
                        scf                             ;
                        ret                             ;

MMUD2                   bit zeuskeybit("N"),a           ;
                        jr z MMLR0                      ;

MMD                     ld a,2                          ;
                        scf                             ;
                        ret                             ;


MMoveUD_Alt             ld bc,zeuskeyaddr("W")          ;
                        in a,(c)                        ;

                        bit zeuskeybit("W"),a           ;
                        jr z MMUD_A1                    ;

                        ld bc,zeuskeyaddr("S")          ;
                        in a,(c)                        ;
                        bit zeuskeybit("S"),a           ;
                        jr z MMUD_A2                    ;

                        or a                            ;
                        ret                             ;

MMUD_A1                 ld bc,zeuskeyaddr("S")          ;
                        in a,(c)                        ;
                        bit zeuskeybit("S"),a           ;
                        jr z MMLR_A0                    ;

                        ld a,0                          ;
                        scf                             ;
                        ret                             ;

MMUD_A2                 ld bc,zeuskeyaddr("W")          ;
                        in a,(c)                        ;
                        bit zeuskeybit("W"),a           ;
                        jr z MMLR_A0                    ;

                        ld a,2                          ;
                        scf                             ;
                        ret                             ;

                        ; See if we want to close a door

MCloseDoor              ld a,[bManMoving] 0             ; Are we moving?
                        or a                            ;
                        jr nz MCheckCloseBehind         ; Yes, check behind

                        ; We're not moving. Close in front?

                        ld hl,KeyCloseP                 ; Close in front?
                        call ReadAKey                   ;
                        ret z                           ;

                        ; We want to close any door ahead of us

                        call IsManNearDoor              ; Look for a door
                        ret nz                          ; None found

                        ; Clear the open request flag

                        xor a                           ; 0
                        ld (bDoorOpenKeepReq),a         ;

                        ; Is it an open door?

MCloseIfOpen            ld a,c                          ; The door character
                        cp ' '                          ; Open?
                        ret nz                          ; No, so ignore

                        jr CloseDoor_HL                 ; Close it

                        ; See if we want to close one behind

MCheckCloseBehind       ld a,(KeyClose)                 ; Pressed?
                        or a                            ;
                        ret z                           ; Nope

                        ; Is there a door here?

                        call IsDoorBehindMan            ; One there?
                        ret nz                          ; No

                        ; Yes, clear the close key

                        xor a                           ; Clear the flag
                        ld (KeyCloseP),a                ;

                        ; Close it

                        jr MCloseIfOpen                 ; As above

; So close the door we just found (HL points at TOP/LEFT char, DE = 1 or 128)

CloseDoor_HL            ld a,cDoorHori                  ; Presume horizontal (DE=1)
                        dec e                           ; Is E=1?
                        jr z CD_Hori                    ; Yes, skip

                        ld a,cDoorVert                  ; It's vertical
CD_Hori                 inc e                           ; Restore

                        ; Close the door

FillDoorway             ld b,4                          ; Length

FD_Lp                   ld (hl),a                       ; Store this character

                        add hl,de                       ; Move that way
                        djnz FD_Lp                      ; Loop

                        ret                             ;

                        ; Now, do we have a pending open/keep request?

MOpenDoor               ld a,[bDoorOpenKeepReq] 0       ;
                        or a                            ;
                        ret z                           ; No, exit

                        dec a                           ; Time it out
                        ld (bDoorOpenKeepReq),a         ;

                        ; Now, first we see if there is anything ahead of us that we might want to keep

                        call AnythingToKeep             ; Anything in out way?
                        ret nz                          ; Yes, we kept something instead.

                        ; Are we near a door

                        call IsManNearDoor              ; Look for a door
                        ret nz                          ; None found

                        ; Clear the open request flag

                        xor a                           ; 0
                        ld (bDoorOpenKeepReq),a         ;

                        ; Is it an open door?

                        ld a,c                          ; The door character
                        cp ' '                          ; Open?
                        ret z                           ; Yes, ignore

                        ; Open the doorway

                        ld a,' '                        ; Clear it
                        jp FillDoorway                  ; As above

; See if the man is standing with a doorway behind him

IsDoorBehindMan         ld hl,(pMan)                    ; We want the square BEHIND the man
                        ld a,(ManAngle)                 ;
                        xor 2                           ;

                        call CDirect                    ;
                        cp 2                            ;
                        jr nz,IDBM1                     ;

                        add hl,de                       ; (Feet)

IDBM1                   add hl,de                       ;

                        jr IMND_NotFeet                 ; Use the code below but with this position

; See if the man is standing near a doorway

IsManNearDoor           ld hl,[pManLookingSquare] 0     ; Get the square the man is facing
                        ld a,(ManAngle)                 ;

                        ; Now, get the direction we look in for the door URDL -> 0/2 -> 1, 1/3 -> 2

IMND_NotFeet            and 1                           ; Are we looking up or down?
                        jr z IMND_HorizDoor             ; Yes, check a horizontal door

                        ; We're looking for a possible vertical doorway

                        ld de,-128                      ;

                        ; Now see if we can find the lintel

                        ld b,6                          ; We will look at up to 6 places for a TOP lintel

IMND_LU_Lp              ld a,(hl)                       ; Get it
                        cp cLintelTOP                   ; Is it?
                        jr z IMND_VD_GotLintel          ; Yes, skip

                        add hl,de                       ; Skip
                        djnz IMND_LU_Lp                 ; Loop

                        ; Not a doorway

                        ret                             ; NZ

                        ; Found the vertical lintel, but is the door open/closed?

IMND_VD_GotLintel       ld de,128                       ; Move to doorway
                        add hl,de                       ;
                        ld a,(hl)                       ; Get it
                        cp ' '                          ; Might be open
                        jr z IMND_VD_CheckOpen          ; Check
                        cp cDoorVert                    ; Is it closed?
                        ret nz                          ; No, skip

                        ; Since we have a door character it must be a valid closed door. Ret Z

                        ld c,a                          ; Return the door character

                        ret                             ; Found

                        ; We're looking at a possible open door, for this to be true there must be 3 more spaces

IMND_VD_CheckOpen       ld b,3                          ; We'll look for this many

                        push hl                         ; Save

IMND_VD_CO_Lp           add hl,de                       ; Move
                        ld a,(hl)                       ; Get it
                        cp ' '                          ; Still space?
                        jr nz IMND_CO_Fail              ; No, open

                        djnz IMND_VD_CO_Lp              ; Loop

                        ; Now, we must also have a bottom lintel

                        add hl,de                       ; Move
                        ld a,(hl)                       ; Get it
                        cp cLintelBOT                   ; Bottom lintel?
                        jr nz IMND_CO_Fail              ; No, open

                        ; Yes, this door is open

                        pop hl                          ; Restore

                        ld c,' '                        ; Return the door character

                        xor a                           ; Z
                        ret                             ; Done

                ; Now see if we can find the lintel

IMND_HorizDoor          ld b,6                          ; We will look at up to 6 places for a LHS lintel

IMND_LL_Lp              ld a,(hl)                       ; Get it
                        cp cLintelLHS                   ; Is it?
                        jr z IMND_HD_GotLintel          ; Yes, skip

                        dec hl                          ; Skip
                        djnz IMND_LL_Lp                 ; Loop

                        ; Not a doorway

                        ret                             ; NZ

                ; Found the horizontal lintel, but is the door open/closed?

IMND_HD_GotLintel       inc hl                          ; Move to doorway
                        ld a,(hl)                       ; Get it
                        cp ' '                          ; Might be open
                        jr z IMND_HD_CheckOpen          ; Check
                        cp cDoorHori                    ; Is it closed?
                        ret nz                          ; No, skip

                        ; Since we have a door character it must be a valid closed door. Ret Z

                        ld c,a                          ; Return the door character
                        ld de,1                         ; Return the direction

                        ret                             ; Found

                ; We're looking at a possible open door, for this to be true there must be 3 more spaces

IMND_HD_CheckOpen       ld b,3                          ; We'll look for this many

                        push hl                         ; Save

IMND_HD_CO_Lp           inc hl                          ; Move
                        ld a,(hl)                       ; Get it
                        cp ' '                          ; Still space?
                        jr nz IMND_CO_Fail              ; No, open

                        djnz IMND_HD_CO_Lp              ; Loop

                        ; Now, we must also have a RHSlintel

                        inc hl                          ; Move
                        ld a,(hl)                       ; Get it
                        cp cLintelRHS                   ; RHS lintel?
                        jr nz IMND_CO_Fail              ; No, open

                        ; Yes, this door is open

                        pop hl                          ; Restore

                        ld c,' '                        ; Return the door character
                        ld de,1                         ; Return the direction

                        xor a                           ; Z
                        ret                             ; Done

                ; Not a valid door

IMND_CO_Fail            pop hl                          ; Restore

                        ; Fall into...

                        xor a                           ; Signal not found
                        inc a                           ;
                        ret                             ;

; Now, we check to see if there is anything to keep in the man's way...

AnythingToKeep          ld hl,(pManLookingSquare)       ; Get the square the man is facing

                        ; Now, see if this is something we can keep...

                        call ATK_Check                  ; Anything we should keep?
                        ret nz                          ; Yes, and we did so exit

                        ; We might want to look down if facing sideways

                        ld a,(ManAngle)                 ;
                        rra                             ;
                        jr nc ATK_Didnt                 ;

                        ld de,128                       ;
                        add hl,de                       ;

                        ; Look to see if this is something we should automatically keep

ATK_Check               ld c,(hl)                       ;
                        ld a,c                          ;
                        and $F0                         ;
                        cp $B0                          ;
                        jr z,ATKTreasure                ;

                        cp $C0                          ;
                        jr z,ATKMagic                   ;

                        ld a,c                          ;
                        and $F8                         ;
                        cp $88                          ;
                        jp z ATKRing                    ;

ATK_Didnt               xor a                           ; Didn't keep anything
                        ret                             ;

                ; Return NZ

ATK_Kept                xor a                           ; Clear the flag
                        ld (bDoorOpenKeepReq),a         ;

                        inc a                           ;
                        ret                             ;

; Grab an item and put it in the swag bag

ATKTreasure             ld a,[TreasureCount] 0          ;
                        cp MaxTreasure                  ;
                        jr z ATK_Didnt                  ;

                        inc a                           ;
                        ld (TreasureCount),a            ;

                        ld e,a                          ;
                        ld d,0                          ;
                        ld ix,SwagBag-1                 ;
                        add ix,de                       ;
                        ld (ix),c                       ;

                        ld a,' '                        ;
                        ld (hl),a                       ;

                        jp ATK_Kept                     ; Clear it

                ; Can we pick any magic up?

ATKMagic                ld a,[CurrentMagic] 0           ; Are we replete?
                        cp MaxMagic                     ;
                        jr nz ATKM_Inc                  ; No, inc it

                        ; We're full of magic. Do we have wounds?

                        ld a,[Wounds] 0                 ; Are we wounded?
                        or a                            ;
                        jr z ATKTreasure                ; We're not, pick this up as if it's treasure

                        call TryToHeal                  ; Try healing. This has to work and reduce the magic

                        ; Increment our magic

ATKM_Inc                ld a,(CurrentMagic)             ; Add one
                        inc a                           ;
                        ld (CurrentMagic),a             ;

                        ; Decrement the magic

                        ld a,(hl)                       ;
                        cp $C0                          ;
                        jr z ATKM_Clear                 ;

                        dec a                           ;
                        ld (hl),a                       ;

ATKM_Replace            ld (hl),a                       ;

                        jp ATK_Kept                     ; Clear it

ATKM_Clear              ld a,' '                        ;
                        jp ATKM_Replace                 ;

; We've picked up a ring

ATKRing                 ld a,MaxMagic                   ; Top up the magic
                        ld (CurrentMagic),a             ;

                        ld a,0                          ; Heal all wounds
                        ld (Wounds),a                   ;

                        ld a,c                          ; Get the ring number
                        and 7                           ;
                        ld e,a                          ;
                        ld d,0                          ;

                        ; Find the right ring

                        ld ix,RingTab                   ;

                        loop lRingTable                 ; * length
                          add ix,de                     ;
                          lend                          ;

                        ld (ix+drt_Floor),$FF           ; Flag that we've picked it up

                        ld a,' '                        ; Clear it
                        ld (hl),a                       ;

                        ld a,c                          ;
                        cp $88                          ; Is this the key?
                        jr nz ATKRingB                  ; No, skip

                        ; Flag that we've picked up the key

                        ld a,8                          ;
                        ld (cFloor),a                   ;

                        ; Inc the ring count

ATKRingB                ld a,(nRings)                   ;
                        inc a                           ;
                        ld (nRings),a                   ;

                        jp ATK_Kept                     ; Clear it

; Now. have we got the right number of rings?

OpenBasement            ld a,[nRings] 0                 ; Got them all?
                        cp 7                            ;
                        ret nz                          ; Nope

                        ld a,[cFloor] 0                 ; On floor zero?
                        or a                            ;
                        ret nz                          ;

                        ; Yes, so open the bottom floor's door...

                        ld hl,TopLeftSanc+13311         ; Open the inner one for a change
                        ld de,-128                      ;
                        ld (hl),cLintelBOT              ;
                        add hl,de                       ;
                        ld (hl),$90                     ;
                        add hl,de                       ;
                        ld (hl),$90                     ;
                        add hl,de                       ;
                        ld (hl),$90                     ;
                        add hl,de                       ;
                        ld (hl),$90                     ;
                        add hl,de                       ;
                        ld (hl),cLintelTOP              ;

                        ret                             ;

OB_OpenDoor             ld a,(hl)                       ;
                        ld (ix),a                       ;

                        add hl,de                       ;
                        add ix,de                       ;

                        djnz OB_OpenDoor                ;

                        ret                             ; Done

        ; These are preserved for use by the monsters

        ; Move along a door looking for the bottom/rhs

MMDoorO2                add hl,de                       ;
                        ld a,(hl)                       ;
                        and $FE                         ;
                        cp $DC                          ;
                        jr z,MMDoorO2                   ;

                        ld a,' '                        ;

                        push hl                         ; Negate DE
                        ld hl,0                         ;
                        or a                            ;
                        sbc hl,de                       ;
                        ex de,hl                        ;
                        pop hl                          ;

                        loop 4                          ;
                          add hl,de                     ; Move that way
                          ld (hl),a                     ; Store this character
                          lend                          ;

                        ret                             ;

; Are we trying to drop something? If we're moving we drop behind, else we drop in front.

MMDrop                  ld a,(TreasureCount)            ;
                        or a                            ;
                        ret z                           ;

                        ld a,(bManMoving)               ; Are we moving?
                        or a                            ;
                        jr z MMDropAhead                ; No, skip

                        ; We're moving, try dropping behind

                        ld a,(KeyDrop)                  ;
                        or a                            ;
                        ret z                           ;

                        ; Clear the persistent flag

                        xor a                           ; We're handling it here
                        ld (KeyDropP),a                 ;

                        ; Right, find the square

                        ld hl,(pMan)                    ; We want the square BEHIND the man
                        ld a,(ManAngle)                 ;
                        xor 2                           ; Reverse the direction
                        jr MMDropAngle                  ;

                        ; We're not moving, so try dropping in front

MMDropAhead             ld hl,KeyDropP                  ;
                        call ReadAKey                   ;
                        ret z                           ;

                        ld hl,(pMan)                    ;
                        ld a,(ManAngle)                 ;

MMDropAngle             call CDirect                    ;
                        cp 2                            ;
                        jr nz,MMDrop1                   ;

                        add hl,de                       ;

MMDrop1                 add hl,de                       ;
                        ld a,(hl)                       ;
                        cp ' '                          ;
                        jr z,MMDrop2                    ;

                        ld a,(ManAngle)                 ;
                        rra                             ;
                        ret nc                          ;

                        ld de,128                       ;
                        add hl,de                       ;
                        ld a,(hl)                       ;
                        cp ' '                          ;
                        ret nz                          ;

MMDrop2                 ld a,(TreasureCount)            ;
                        ld c,a                          ;
                        ld b,0                          ;
                        ld ix,SwagBag-1                 ;
                        add ix,bc                       ;

                        ld a,(ix)                       ;
                        ld (hl),a                       ;

                        dec c                           ;
                        ld a,c                          ;

                        ld (TreasureCount),a            ;
                        ret                             ;

; Drive the sword

MSword                  ld a,[SwdPhase] 0               ; Are we swinging it?
                        or a                            ;
                        jr nz,MSDoing                   ; Yes, calc next position

                        ; Can we?

                        ld hl,[pMan] 0                  ; Check for force-field
                        ld a,(hl)                       ;
                        cp $90                          ;
                        jr z MSword_Nope                ; Yes, so don't allow the sword

                        ; No, is the "S" key pressed?

                        ld hl,KeySwordP                 ; "S" pressed?
                        call ReadAKey                   ;
                        jr z MSword_Auto                ; No, skip

                        xor a                           ; Clear it
                        ld (KeySwordP),a                ;

                        ; Setup the swing

MSA_Start               ld a,9+1                        ; 9 phases
                        ld (SwdPhase),a                 ;

                        jp MSDoing                      ; Drive it

                        ; We can't swing the sword so clear any request that's pending

MSword_Nope             xor a                           ; Clear it
                        ld (KeySwordP),a                ;
                        ret                             ; Done

        ; Is there a monster in the sword range?

MSword_Auto             ld hl,(pMan)                    ; Our head's position
                        ld a,[ManAngle] 0               ; Which way are we facing?

                        cp 3                            ;
                        jr z MSA_Left                   ;

                        cp 1                            ;
                        jr z MSA_Right                  ;

                        cp 0                            ;
                        jr z MSA_Up                     ;

                        ; Assume down

                        inc h                           ; + 128 * 2
                        dec hl                          ; Left

MSA_LR3                 call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        inc hl                          ; Next char

                        call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        inc hl                          ; Next char

                        call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        ret                             ; Done

        ; Is this a monster?

MSA_IsMonster           ld a,(hl)                       ; Get the char
                        and $F8                         ; Clip out irrelevent
                        cp $D0                          ; Monster=ZF
                        ret                             ;

        ; Try up

MSA_Up                  ld de,-129                      ; Up and left
                        add hl,de                       ;
                        jp MSA_LR3                      ; As above

        ; Try right

MSA_Right               inc hl                          ; Look right

MSA_UD2                 call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        ld de,128                       ; Down
                        add hl,de                       ;

                        call MSA_IsMonster              ; Is this a monster?
                        jr z MSA_Start                  ; Yes

                        ret                             ; Done

        ; Try left

MSA_Left                dec hl                          ; Look left
                        jp MSA_UD2                      ; As above

        ; Swing the sword. This changes according to the man's direction

MSDoing                 ld a,(SwdPhase)                 ; Get the phase
                        or a                            ;
                        ret z                           ; 0=don't

                        dec a                           ;
                        ld (SwdPhase),a                 ;
                        or a                            ;
                        jr z KillSword                  ;

                        ; Calc the new sword position

                        ld a,(ManAngle)                 ; Which way are we facing?
                        call CDirect                    ;

                        ld hl,(pMan)                    ; Add the offset
                        add hl,de                       ;

                        cp 2                            ; If it's down we add it again
                        jr nz,MSword1                   ; to skip the feet...

                        add hl,de                       ; It is...

                        ; Now, calc the offset and sword character

MSword1                 ld iy,SwdUpTab                  ;

                        ld a,(ManAngle)                 ;
                        rlca                            ; * 32
                        rlca                            ;
                        rlca                            ;
                        rlca                            ;
                        rlca                            ;

                        ld d,0                          ;
                        ld e,a                          ;

                        add iy,de                       ;

                        ld a,(SwdPhase)                 ;
                        ld b,a                          ;

                        ld a,9                          ;
                        sub b                           ;
                        ld b,a                          ;

                        add a,a                         ;
                        add a,b                         ;

                        ld e,a                          ;
                        add iy,de                       ;

                        ld e,(iy+dst_Off_L)             ;
                        ld d,(iy+dst_Off_H)             ;
                        add hl,de                       ;

                        ld a,(hl)                       ; Character under sword

                        cp $FD                          ; Stairs
                        ret z                           ; Yes, ignore

                        and $FE                         ;
                        cp $DC                          ;
                        ret z                           ;

                        and $F8                         ;
                        cp $D0                          ;
                        jr z,MSHitMon                   ;

                        and $F0                         ;
                        cp $90                          ;
                        ret z                           ;

                        ld a,(iy+dst_Char)              ;
                        ld (SwdChar),a                  ;
                        ld (SwdPos),hl                  ; Set the position

                        ret                             ;

KillSword               ld hl,0                         ;
                        ld (SwdPos),hl                  ;
                        ret                             ;

MSHitMon                ld a,SwordDamageToMon           ;
                        ld b,$DE                        ;
                        call HitMonster                 ;

                        ret                             ;

; Slow healing process

SlowlyHeal              ld a,(Wounds)                   ; Do we have wounds?
                        or a                            ;
                        ret z                           ; Nope

                        ld b,a                          ; Save

                        ; Yes.

                        ld a,(CurrentMagic)             ; Do we have enough magic?
                        cp 20                           ;
                        ret c                           ; Nope

                        ; Dec zem both

                        dec a                           ;
                        ld (CurrentMagic),a             ;

                        ld a,b                          ;
                        dec a                           ;
                        ld (Wounds),a                   ;

                        ret                             ; Done

; See if the man can move here and return CF if not.
; If we've hit something try picking it up

TestManMove             push hl                         ; Store putative new position

                        ; Can we turn this into a gate?

                        ld a,(bJokeEnable)              ;
                        ld e,a                          ;

                        ld a,(KeyPortalP)               ; Portal pressed
                        and e                           ;
                        call nz ManMakePortal           ; If we can, do

                        ld a,(hl)                       ; Is the head blocked?
                        cp cLintelLHS                   ; By a LHS lintel?
                        call z SetJinkRightIfUp         ; Yes
                        cp cLintelRHS                   ; By a RHS lintel?
                        call z SetJinkLeftIfUp          ; Yes
                        cp cLintelLHS                   ; By a LHS lintel?
                        call z SetJinkDownIfLeft        ; Yes
                        cp cLintelRHS                   ; By a RHS lintel?
                        call z SetJinkDownIfRight       ; Yes
                        cp cLintelTOP                   ; By a TOP lintel?
                        call z SetJinkDownIfLeft        ; Yes
                        cp cLintelTOP                   ; By a TOP lintel?
                        call z SetJinkDownIfRight       ; Yes

                        call ManValid                   ;
                        jp nz TMM_Fail                  ; Yes, failed

                        ld de,128                       ; Look down
                        add hl,de                       ;

                        ld a,(hl)                       ; Are the feet blocked?
                        cp cLintelLHS                   ; By a LHS lintel?
                        call z SetJinkRightIfDown       ; Yes
                        cp cLintelRHS                   ; By a RHS lintel?
                        call z SetJinkLeftIfDown        ; Yes
                        cp cLintelLHS                   ; By a LHS lintel?
                        call z SetJinkUpIfLeft          ; Yes
                        cp cLintelRHS                   ; By a RHS lintel?
                        call z SetJinkUpIfRight         ; Yes
                        cp cLintelBOT                   ; By a LHS lintel?
                        call z SetJinkUpIfLeft          ; Yes
                        cp cLintelBOT                   ; By a RHS lintel?
                        call z SetJinkUpIfRight         ; Yes

                        call ManValid                   ;
                        jp nz TMM_Fail                  ; Yes, failed

                        pop hl                          ; Restore

                        or a                            ; We could move
                        ret                             ;

                        ; Failed

TMM_Fail                pop hl                          ; Restore
                        scf                             ; Failed
                        ret                             ;

; Set the jink flags

SetJinkUpIfRight        ld a,(ManAngle)                 ; Right?
                        cp 1                            ;
JinkUp                  jr nz JinkX                     ; No

                        ld a,4                          ;
                        ld (JinkDirnUD),a               ;

                        jr JinkX                        ; As below

; Set the jink flags

SetJinkUpIfLeft         ld a,(ManAngle)                 ; Left?
                        cp 3                            ;
                        jr JinkUp                       ;

; Set the jink flags

SetJinkDownIfRight      ld a,(ManAngle)                 ; Right?
                        cp 1                            ;
JinkDown                jr nz JinkX                     ; No

                        ld a,2                          ;
                        ld (JinkDirnUD),a               ;

                        jr JinkX                        ; As below

; Set the jink flags

SetJinkDownIfLeft       ld a,(ManAngle)                 ; Left?
                        cp 3                            ;
                        jr JinkDown                     ;


; Set the jink flags

SetJinkLeftIfUp         ld a,(ManAngle)                 ; Up?
                        cp 0                            ;
JinkLeft                jr nz JinkX                     ; No

                        ld a,3                          ;
                        ld (JinkDirn),a                 ;

                        jr JinkX                        ; As below

; Set the jink flags

SetJinkLeftIfDown       ld a,(ManAngle)                 ; Down?
                        cp 2                            ;
                        jr JinkLeft                     ;

; Set the jink flags

SetJinkRightIfUp        ld a,(ManAngle)                 ; Up?
                        cp 0                            ;
JinkRight               jr nz JinkX                     ; No

                        ld a,1                          ;
                        ld (JinkDirn),a                 ;

JinkX                   ld a,(hl)                       ;
                        ret                             ;

; Set the jink flags

SetJinkRightIfDown      ld a,(ManAngle)                 ; Down?
                        cp 2                            ;
                        jr JinkRight                    ;

; Is this a character the man can move onto? z = Valid

ManValid                cp ' '                          ; Space is OK
                        ret z                           ;

                        cp deadMon_Steaming             ; Steaming?
                        jr c MV_1                       ; No, skip
                        cp deadMon_Steaming+4           ; Steaming?
                        jr c ManHitThing                ; Yes

MV_1                    cp deadMon_Steamed              ; Dead thing?
                        jr z ManHitThing                ;
                        cp deadMon_Sword                ; Dead thing?
                        jr z ManHitThing                ;
                        cp deadMon_Arrow                ; Dead thing?
                        jr z ManHitThing                ;

                        cp $90                          ; Force-field?
                        jp z OpenPlan                   ; Yes, see how we should treat it...

                        and $FE                         ; Landing
                        cp $FC                          ;
                        ret z                           ;

                        and $F8                         ; The different Landings
                        cp $80                          ;
                        ret                             ;

                        ; We've hit a dead thing. Can we move it?

ManHitThing             call FindThing_HL               ; Find the thing we've hit and shove it

                        ; Now, can we move it?

                        push hl                         ; Save the pMan

                        ld a,(ManAngle)                 ; Which way are we facing?
                        call CDirect                    ;

                        add hl,de                       ;

                        ld a,(hl)                       ; Is this clear?
                        cp ' '                          ;
                        jr nz MHT_Done                  ; No, don't move it

                        ; Yes, we can move to this point.

                        pop hl                          ; Restore the address

                        ld (hl),' '                     ;

                        push hl                         ;
                        add hl,de                       ;

                        ld (iy+dm_pMaze_L),l            ;
                        ld (iy+dm_pMaze_H),h            ;

                        ld a,(iy+dm_Char)               ; Draw it in the new pos
                        ld (hl),a                       ;

                        ; Return NZ

MHT_Done                pop hl                          ; Restore
                        xor a                           ; NZ
                        inc a                           ;

                        ret                             ;

; Find the thing at HL

FindThing_HL            ld iy,MonsterList               ;
                        ld de,lMonst                    ;

                        ld b,nMonst                     ; n-1?

FT_Lp                   ld a,(iy+dm_pMaze_L)            ;
                        cp l                            ;
                        jp nz FT_Nope                   ;

                        ld a,(iy+dm_pMaze_H)            ;
                        cp h                            ;
                        ret z                           ;

FT_Nope                 add iy,de                       ;
                        djnz FT_Lp                      ;

                        ret                             ;

; Add an angle to HL

AddAngle_A_HL           ld de,128                       ;
                        or a                            ;
                        sbc hl,de                       ;

                        cp 0                            ; 0 -> UP
                        ret z                           ;

                        add hl,de                       ; Restore
                        inc hl                          ; Assume RIGHT

                        cp 1                            ; 1 -> RIGHT
                        ret z                           ;

                        dec hl                          ; Restore
                        add hl,de                       ; Assume DOWN

                        cp 2                            ; 2 -> DOWN
                        ret z                           ;

                        or a                            ; Restore
                        sbc hl,de                       ;
                        dec hl                          ; Must be LEFT

                        ret                             ; Done

ManSetOpenReq           push af                         ;

                        ld a,1                          ; Try to open something
                        ld (bDoorOpenKeepReq),a         ;

                        pop af                          ;
                        ret                             ;

; Show him dead

MDead                   inc a                           ; Inc the timer
                        jp z LeaveGame                  ;

                        ld (GameBType),a                ;

                        ret                             ; Done

; Move the man

MoveMan                 ld a,[MManDelay] 0              ; Time to move?
                        or a                            ;
                        ret p                           ;

                        ; Now, if this was our first move we have a longer delay

                        ld a,(bManMoving)               ; Were we moving?
                        or a                            ;

                        ld a,ManSpeed                   ; Setup delay
                        jr nz MM_GotSpeed               ; We weren't moving

                        ld a,ManDelSlow                 ; Setup slower delay

MM_GotSpeed             ld (MManDelay),a                ;

                        ld a,[GameBType] 0              ; Are we dead?
                        or a                            ;
                        jp m MDead                      ; Yes, show him dead

                        call SlowlyHeal                 ; Heal some wounds

                        call MOpenDoor                  ; Open or keep anything?

                        call MCloseDoor                 ; Close a door?

                        call MMDrop                     ; Drop anything?

                        ; Don't allow attacks while in the doorway of the stairs

                        ld hl,(pMan)                    ; Check for force-field
                        ld a,(hl)                       ;
                        cp $90                          ;
                        jr z MMan5                      ; Skip if in doorway

                        call MFireArrow                 ; Fire an arrow?

                        call FireBall                   ; Fire a fireball?

                        call Lightning                  ; Fire lightning?

                        ; Move the man

MMan5                   xor a                           ; Clear the weapon key flags
                        ld (KeyArrowP),a                ;
                        ld (KeyFireP),a                 ;
                        ld (KeyLightP),a                ;
                        ld (bManMoving),a               ;

                        ; See if we can move up/down. Do so if we can.

                        ld a,(ManAngle)                 ; Save the posn.
                        ld (OldManAngle),a              ;

                        ld hl,(pMan)                    ;
                        ld (OldpMan),hl                 ;

                        ;

                        ld hl,(pMan)                    ; Get the current position
                        ld (nMan),hl                    ; Presume OK

                        ; If he's shown, remove him

                        ld a,[UnderMan] 0               ; Anything under the man?
                        or a                            ;
                        jr nz MoveMANCleared            ; Yes, skip

                        ; Clear the man from the maze

                        ld (hl),' '                     ; Clear under the man
                        ld de,128                       ;
                        add hl,de                       ;
                        ld (hl),' '                     ;
                        sbc hl,de                       ; Move back

                        ; We're clear

MoveMANCleared          call MMoveUD                    ; Trying to move U/D?
                        jr nc MMoveNotUD_PossJink       ; No, skip

MMoveNotUD_Jink         and $3                          ; Lose the jink bit
                        ld (ManAngle),a                 ; Save the angle

                        ; Is this a valid position?

                        call AddAngle_A_HL              ; Add it

                        call TestManMove                ; Could we move here?
                        call c ManSetOpenReq            ; No, try to open/pick up
                        jr c MMoveNotUD                 ; No, skip

                        ; Yes, we could move to here

                        ld (nMan),hl                    ; Save the position
                        jr MMoveNotUD                   ;

MMoveNotUD_PossJink     ld a,[JinkDirnUD] 0             ; Got one?
                        or a                            ;
                        jr nz MMoveNotUD_Jink           ; Yes, jink

                        ; Check L/R

MMoveNotUD              xor a                           ; Clear the jink flags
                        ld (JinkDirnUD),a               ;

                        ld hl,[nMan] 0                  ; Restore if required

                        call MMoveLR                    ; Trying to move L/R?
                        jr nc MMoveNotLR_PossJink       ; No, jink?

                        ld (ManAngle),a                 ; Save the angle

                        ; Is this a valid position?

MMoveNotLR_Jink         call AddAngle_A_HL              ; Add it

                        call TestManMove                ; Could we move here?
                        call c ManSetOpenReq            ; No, try to open/pick up
                        jr c MMoveControlsDone          ; No, skip

                        ; Yes, we could move to here

                        ld (nMan),hl                    ; Save the position
                        jr MMoveControlsDone            ;

MMoveNotLR_PossJink     ld a,[JinkDirn] 0               ; Got one?
                        or a                            ;
                        jr nz MMoveNotLR_Jink           ; Yes, jink

MMoveControlsDone       xor a                           ; Clear the jink flags
                        ld (JinkDirn),a                 ;

                        ; Undraw only if position or angle changed

                        ld a,[OldManAngle] 0            ; Has the angle changed?
                        ld b,a                          ;
                        ld a,(ManAngle)                 ;
                        cp b                            ;
                        jr nz MManAngleChanged          ;

                        ; Position?

                        ld hl,(nMan)                    ;
                        ld de,[OldpMan] 0               ;
                        or a                            ;
                        sbc hl,de                       ;
                        jr nz MManChanged               ; Yes

                        jp MManNotMoved                 ;

MManAngleChanged        ld hl,(pMan)                    ; Position hasn't
                        ld (nMan),hl                    ;
                        jr MManNotMoved                 ;

                        ; Undraw

MManChanged             ld a,1                          ; We're moving
                        ld (bManMoving),a               ;

                        ; Move to here

MManNotMoved            ld hl,(nMan)                    ; Store putative new position

                        ld a,0                          ; We're not on a new floor
                        ld (NFloorFl),a                 ;

                        ld de,128                       ; Look down
                        add hl,de                       ;

                        ; We can move to here, but check if we're on a landing
                        ; This is the foot position

                        ld a,(hl)                       ; Could we be on a landing?
                        cp $80                          ;
                        call nc MManRE1                 ; Perhaps, check...

                        xor ' '                         ; Set this flag if there's something
                        ld (UnderMan),a                 ; other than a space under the man

                        ld hl,(nMan)                    ; Move to here...
                        ld (pMan),hl                    ;

                        ; We're visible, show it here

                        call PlaceMan                   ; Show the man

                        ; See if we're on a landing

                        ld a,(NFloorFl)                 ; On a landing?
                        or a                            ;
                        call nz NFloor                  ; Yes, see if the floor has changed

                        jp MSword                       ; Drive the sword

; See if we can make a hole in a wall

ManMakePortal           ld a,l                          ; Outside wall?
                        and $7F                         ;
                        ret z                           ; Nope LHS
                        cp $7F                          ;
                        ret z                           ; Nope RHS

                        ld a,(hl)                       ;
                        cp $9C                          ;
                        ret nz                          ;

                        ld de,128                       ; Look down
                        add hl,de                       ;

                        ld a,(hl)                       ;
                        cp $9C                          ;
                        jr z CanMakePortal              ;

                        or a                            ;
                        sbc hl,de                       ;
                        ret                             ;

                ; We can do it here, so do it...

CanMakePortal           ld (hl),$90                     ; Do so
                        or a                            ;
                        sbc hl,de                       ;
                        ld (hl),$90                     ;

                        xor a                           ; Clear the flag
                        ld (KeyPortalP),a               ;

                        ret                             ; Done

; On a landing?

MManRE1                 cp $88                          ; Landing char?
                        ret nc                          ; No, exit

                        ; We're on a landing. Calc the floor...

                        and $7                          ; Calc the floor, 1..8
                        inc a                           ;
                        ld (NFloorFl),a                 ;

                        ld a,(hl)                       ; Restore the char
                        ret                             ; Done

; Update the map_nextpos and draw the man in the maze and on the screen

PlaceMan                ld a,(GameBType)                ; Are we dead
                        or a                            ;
                        ret m                           ; Yes, exit

                        ; Update the square we're looking at

                        ld hl,(pMan)                    ; Get the square the man is facing
                        ld a,(ManAngle)                 ;
                        call CDirect                    ; DE:= offset in the facing direction

                        add hl,de                       ;
                        cp 2                            ; Looking down?
                        jr nz,PM_NotFeet                ; No, skip

                        add hl,de                       ; Move past the feet

PM_NotFeet              ld (pManLookingSquare),hl       ; Save a pointer to it

                        add a,a                         ; Calc the right char for this angle
                        add a,$A8                       ;
                        ld b,a                          ;

                        ld hl,(pMan)                    ; Get the man's position

                        ld a,(hl)                       ; Check the char under the head
                        cp $80                          ;
                        ld a,b                          ;
                        ret nc                          ; Don't draw him in the maze if he's on a force-field or stairs, basically

                        ; Can overwrite this character

                        ld (hl),a                       ; Store the head in the maze
                        ld de,128                       ; Move down
                        add hl,de                       ;
                        inc a                           ;
                        ld (hl),a                       ; Store feet

                        ret                             ;

; Justify our position on screen?

JustifyScreen           ld hl,KeyspP                    ;
                        call ReadAKey                   ;
                        ret z                           ;

                        ret                             ;

; Convert to screen co-ordinates. NC means visible...

SCVNew                  push de                         ;
                        push af                         ;

                        ; Get this as an X/Y in DE

                        ld a,l                          ; Get X
                        and $7F                         ;
                        add hl,hl                       ; H:=Y+Offset BigMaze starts at C000 so offset = 80
                        ld e,a                          ;

                        ld a,h                          ;
                        and $7F                         ; Lose the offset
                        ld d,a                          ;

                        ; See if we're visible

                        ld hl,(pFrameX)                 ;
                        ld a,e                          ;
                        sub l                           ;
                        ld l,a                          ;

                        cp XW                           ;
                        jr nc SCVF                      ;

                        ld a,d                          ;
                        sub h                           ;
                        ld h,a                          ;

                        cp YW                           ;
                        jr nc SCVF1                     ;

                        pop af                          ;
                        pop de                          ;
                        or a                            ;
                        ret                             ;

SCVF                    ld a,d                          ;
                        sub h                           ;
                        ld h,a                          ;

SCVF1                   pop af                          ;
                        pop de                          ;
                        scf                             ;
                        ret                             ;

; Convert a big-maze pointer to L=X, H=Y

ConvBM_To_XY_HL         ld a,l                          ; Get X
                        and $7F                         ;
                        add hl,hl                       ; H:=Y+Offset BigMaze starts at C000 so offset = 80
                        ld l,a                          ;

                        ld a,h                          ;
                        and $7F                         ;
                        ld h,a                          ;

                        ret                             ;

InitTreasure            ld b,nTreasure                  ;

InitTLoop               push bc                         ;

                        call FindPosition               ;

                        call RandOnly_A                 ;
                        and $F                          ;
                        or $B0                          ;
                        ld (hl),a                       ;

                        pop bc                          ;
                        djnz InitTLoop                  ;

                        ret                             ;

InitMagic               ld b,nMagic                     ;

InitMLoop               push bc                         ;

                        call FindPosition               ;

                        call RandOnly_A                 ;
                        and $7                          ;
                        or $C8                          ;
                        ld (hl),a                       ;

                        pop bc                          ;
                        djnz InitMLoop                  ;

                        ret                             ;

; Find an empty square in the maze

FindPosition            call Rand                       ;

                        ld hl,(Seed)                    ;
                        ld a,l                          ;
                        and $7F                         ;
                        cp $70                          ;
                        jr nc FindPosition              ;

                        ld a,h                          ;
                        and $3F                         ;
                        ld h,a                          ;
                        cp $38                          ;
                        jr nc FindPosition              ;

                        push de                         ;
                        ld de,BigMaze                   ;
                        add hl,de                       ;
                        pop de                          ;

                        ld a,(hl)                       ; Empty?
                        cp ' '                          ;
                        jr nz,FindPosition              ; No, find another one...

                        ret                             ;

ClearMonsters           ld b,nMonst                     ;
                        ld ix,MonsterList               ;

CMonsLp                 push bc                         ;
                        push ix                         ;
                        call InitDummyMons              ;
                        pop ix                          ;

                        ld a,$FF                        ; Slow
                        ld (ix+dm_iSpeed),a             ;
                        ld (ix+dm_Flags),a              ; Dead

                        ld bc,lMonst                    ;
                        add ix,bc                       ;

                        pop bc                          ;
                        djnz CMonsLp                    ;
                        ret                             ; Done

InitDummyMons           ld iy,MonsterTypes              ;
                        ld b,lMonsterFixed              ;

IDM2                    push bc                         ;

                        ld a,(iy)                       ; Base
                        ld (ix),a                       ; Store

                        inc ix                          ;
                        inc iy                          ;

                        pop bc                          ;
                        djnz IDM2                       ;

                        ; Find somewhere for it
                        ; IX now has an offset of lMonsterFixed

                        ld hl,BigMaze+$101              ;

                        ld (ix+dm_pMaze_L-lMonsterFixed),l;
                        ld (ix+dm_pMaze_H-lMonsterFixed),h;

                        ; Clear to the end of the monster

                        ld b,lMonst-lMonsterFixed       ;

IDM3                    ld (ix),0                       ;
                        inc ix                          ;
                        djnz IDM3                       ;

                        ret                             ;

InitMonsters            ld b,nMonst                     ;
                        ld ix,MonsterList               ;

IMons0                  push bc                         ;
                        push ix                         ;
                        call IMons1                     ;
                        pop ix                          ;

                        ld a,(ix+dm_cSpeed)             ; Set the dynamic speed
                        ld (ix+dm_iSpeed),a             ;

                        ld bc,lMonst                    ;
                        add ix,bc                       ;

                        pop bc                          ;
                        djnz IMons0                     ;

                        ; Make more of the monsters nasty?

                        ld a,(GameBType)                ; Faster monsters?
                        bit 1,a                         ;

                        ld a,14                         ; 14 of them on each floor
                        jr nz Nasty                     ; Jmp if faster

                        ; Exit if we're in the basement

                        ld a,(cFloor)                   ;
                        or a                            ;
                        ret z                           ;

                        ; Make some nastier, more on the higher floors

Nasty                   ld ix,MonsterList-lMonst        ;
                        ld de,lMonst                    ;

IMons4                  add ix,de                       ;
                        ld (ix+dm_Magic),$FF            ;
                        ld (ix+dm_cSpeed),30            ;
                        ld (ix+dm_iSpeed),30            ;

                        dec a                           ;
                        jr nz,IMons4                    ;

                        ld (ix+dm_Wounds),$FF           ;
                        ret                             ;

            ; Init a monster.

IMons1                  ld iy,MonsterTypes              ;
                        ld b,lMonsterFixed              ;

IMons2                  push bc                         ;

                        ld a,(iy+lMonsterFixed)         ; Get the variation
                        call RandRange                  ; Rand 0..Var-1
                        add a,(iy)                      ; +Base
                        ld (ix),a                       ; Store

                        inc ix                          ;
                        inc iy                          ;

                        pop bc                          ;
                        djnz IMons2                     ;

                        ; Find somewhere for it
                        ; IX now has an offset of lMonsterFixed

                        call FindPosition               ;

                        ld (ix+dm_pMaze_L-lMonsterFixed),l;
                        ld (ix+dm_pMaze_H-lMonsterFixed),h;

                        ; This didn't mark the position in any way, so potentially a ring could be put under the monster...

                        ld a,[bBuilding] 0              ; Are we building for the first time?
                        or a                            ;
                        jr z IMon_DontPlace             ; No, don't place it

                        ; We are, so mark it

                        ld a,(ix+dm_Char-lMonsterFixed) ;
                        ld (hl),a                       ;

                        ; Clear to the end of the monster

IMon_DontPlace          ld b,lMonst-lMonsterFixed       ;

IMons3                  ld (ix),0                       ;
                        inc ix                          ;
                        djnz IMons3                     ;

                        ret                             ;

; Place the monsters in the maze

PlaceMon                ld b,nMonst                     ;
                        ld ix,MonsterList               ;
                        ld de,lMonst                    ;

PlaceMonL               ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld a,(ix+dm_Char)               ;
                        ld (hl),a                       ;
                        add ix,de                       ;

                        djnz PlaceMonL                  ;

                        ret                             ;

; Get a random number less than A

RandRange               or a                            ;
                        ret z                           ;

                        push hl                         ;
                        push de                         ;
                        push bc                         ;

                        ld c,a                          ;
                        call RandOnly_A                 ;
                        ld l,a                          ;
                        xor a                           ;
                        ld b,8                          ;
RandR1                  rl l                            ;
                        rla                             ;
                        cp c                            ;
                        jr c RandR2                     ;

                        sub c                           ;
RandR2                  djnz RandR1                     ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ;

; Move the monsters

MoveMonsters            ld b,nMonst                     ;
                        ld ix,MonsterList               ;
                        ld de,lMonst                    ;

MM_Lp                   dec (ix+dm_Delay)               ;
                        jr z MM_Move                    ;

                        add ix,de                       ;

                        djnz MM_Lp                      ;
                        ret                             ;

                ; Move then loop

MM_Move                 call DoMoveMonster              ;

                        ld de,lMonst                    ;
                        add ix,de                       ;

                        djnz MM_Lp                      ;
                        ret                             ;

; Move a monster

DoMoveMonster           ld a,(ix+dm_cSpeed)             ; Reset the speed
                        ld (ix+dm_Delay),a              ;

                        bit 7,(ix+dm_Flags)             ; Is it dead?
                        jp nz MoveDeadMonster           ; Yes, animate it

                        bit 0,(ix+dm_Combat)            ; Are we being targetted?
                        jr z MMons2A                    ; No, skip

                        ; We're under attack, we need to wake up

                        ld a,(ix+dm_Char)               ; Are we sleeping?
                        cp cSleepingMonster             ;
                        jr nz MMons2Z                   ; No, so carry on

                        ; Yes, so change our character to something else

                        ld a,r                          ; Random character
                        and $7                          ;
                        or $D0                          ;
                        cp cSleepingMonster             ; But not this one
                        jr nz MMons2B                   ;

                        inc a                           ;

MMons2B                 ld (ix+dm_Char),a               ; Set this character

                        jp MMons2Z                      ;

                ; Not under attack so should we doze off?

MMons2A                 ld a,(ix+dm_Char)               ;
                        cp cSleepingMonster             ;
                        jr z,MMons2Z                    ;

                        ; This isn't a sleeping monster, should it fall asleep?

                        ld a,(Seed+1)                   ;
                        ld c,a                          ;
                        ld a,r                          ;
                        or c                            ;
                        and $3F                         ;
                        jr nz MMons2Z                   ; No.

                        ; Can it be seen?

                        push hl                         ;
                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;

                        call SCVNew                     ;
                        jr nc MMons2X                   ;

                        ; It can't be seen, so goto sleep

                        ld (ix+dm_Char),cSleepingMonster;

                        ; We're not on screen

MMons2X                 pop hl                          ;

                        ; General monster move

MMons2Z                 push bc                         ;

                        ; Remove the thing from the bigmaze

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;

                        ld (hl),' '                     ; Clear it

                        ; If we are asleep we don't undraw them or move to prevent tell-tale flicker...

                        ld a,(ix+dm_Char)               ;
                        cp cSleepingMonster             ;
                        jp z,MMons5                     ;

                        ; Setup the "return" address

                        ld hl,MMons5                    ;
                        push hl                         ;

                        ; What sort of thing is it?

                        ld a,(ix+dm_MoveType)           ; 1
                        bit 6,a                         ; Is this an alternate move?
                        jp nz MoveThingRandom           ; Yes, skip

                        cp 1                            ;
                        jp c MoveThingWallFollowLHS     ; 0
                        jp z MoveThingWallFollowRHS     ; 1

                        cp 3                            ;
                        jp c MoveThingRandom            ; 2
                        jp z MoveThingRandCoward        ; 3

                        ; 4/5

                        cp 4                            ;
                        jp z MoveThingCowardWF_LHS      ; 4
                        jp MoveThingCowardWF_RHS        ; 5

                        ; This is a wall-following coward...

MoveThingCowardWF_LHS   bit 0,(ix+dm_Combat)            ; Is this visible to the man?
                        jr nz MTWF_LHS_Seen             ; Yes, skip

                        res 1,(ix+dm_Combat)            ; Clear the was visible flag
                        jp MoveThingWallFollowLHS       ; Same as wall-follower

                        ; We can be seen

MTWF_LHS_Seen           bit 1,(ix+dm_Combat)            ; Was this visible to the man?
                        jp nz MoveThingWallFollowLHS    ; Yes, no change

                        ; We've just become visible

                        set 1,(ix+dm_Combat)            ; Set the was visible flag

                        ; Change walls

                        ld (ix+dm_MoveType),5           ; WF rhs
                        jp MoveThingWallFollowRHS       ; Yes, do it

                ; This is a wall-following coward...

MoveThingCowardWF_RHS   bit 0,(ix+dm_Combat)            ; Is this visible to the man?
                        jr nz MTWF_RHS_Seen             ; Yes, skip

                        res 1,(ix+dm_Combat)            ; Clear the was visible flag
                        jp MoveThingWallFollowRHS       ; Same as wall-follower

                ; We can be seen

MTWF_RHS_Seen           bit 1,(ix+dm_Combat)            ; Was this visible to the man?
                        jp nz MoveThingWallFollowRHS    ; Yes, no change

                        ; We've just become visible

                        set 1,(ix+dm_Combat)            ; Set the was visible flag

                        ; Change walls

                        ld (ix+dm_MoveType),4           ; WF lhs
                        jp MoveThingWallFollowLHS       ; Yes, do it

                ; Random coward

MoveThingRandCoward     bit 0,(ix+dm_Combat)            ; Is this visible to the man?
                        jr nz MTRC_Seen                 ; Yes, skip

                        res 1,(ix+dm_Combat)            ; Clear the was visible flag
                        jp MoveThingRandom              ; Same as random

                ; We can be seen

MTRC_Seen               bit 1,(ix+dm_Combat)            ; Was this visible to the man?
                        jp nz MoveThingRandom           ; Yes, no change, same as random

                        ; We've just become visible

                        set 1,(ix+dm_Combat)            ; Set the was visible flag

                        ; We want to move away from the man ideally, but for the moment we'll just reverse

                        ld a,(ix+dm_Dirn)               ; Rotate the angle by 2
                        add a,2                         ;
                        and $7                          ;
                        ld (ix+dm_Dirn),a               ;

                        jp MoveThingRandom              ; Random

                ; We've moved it, see if it wants to fight

MMons5                  call CheckCombat                ; See if it wants to fight

                        ; Now, re-draw it

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;

                        ld a,(ix+dm_Char)               ;
                        ld (hl),a                       ; Write it to BM

                        pop bc                          ;
                        ret                             ;

; Dynamic monsters

NHack1a                 ld a,(GameBType)                ; Are we dynamic?
                        bit 2,a                         ;
                        ret z                           ; No, exit

                        ; We're slowing down

                        ld a,(ix+dm_cSpeed)             ; We are slowing back down
                        ld c,(ix+dm_iSpeed)             ; Back to this
                        add a,delSp                     ;
                        cp c                            ;
                        ret nc                          ;

                        ld (ix+dm_cSpeed),a             ;
                        ret                             ;

; See if we want to attack

MonCelebrate            call MonCelebrate2              ; Fire lightning at him
                        ld a,r                          ;
                        and $03                         ;
                        ld hl,sCeleb                    ;
                        add hl,a                        ;
                        ld a,(hl)                       ;
                        ld (iy+dp_MissileChar),a        ; Different character

                        ld hl,MoveCelebrate             ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ret                             ; Done

sCeleb                  db "ha!",$F5                    ;

CheckCombat             call FindProjSpace              ; Any projectile space?
                        ret z                           ;

                        ld e,(ix+dm_pMaze_L)            ;
                        ld d,(ix+dm_pMaze_H)            ;
                        ld hl,(pMan)                    ;
                        ld c,50                         ;
                        call RangeLook                  ;

                        ld (iy+dp_Life),0               ;
                        res 0,(ix+dm_Combat)            ;
                        jr c NHack1a                    ; Can't see the man

                        ; We can see the man

                        ld a,(GameBType)                ; Are we dynamic?

                        bit 7,a                         ; Man dead?
                        jr nz MonCelebrate              ;

                        bit 2,a                         ;
                        jr z NHack1                     ; No, skip

                        ; Speed up

                        ld a,(ix+dm_cSpeed)             ; Speed up to max speed
                        sub delSp                       ;
                        cp mDynamMaxSpeed               ;
                        jr c NHack1                     ;
                        ld (ix+dm_cSpeed),a             ;

                        ; Flag that the man isn't a virgin any longer

NHack1                  ld a,1                          ; Not a virgin any more
                        ld (Virgin),a                   ;

                        set 0,(ix+dm_Combat)            ; Set that it can see the man

                        ; Is this a pure vertical or horizontal?

                        ld a,(iy+dp_ErrS)               ;
                        or a                            ;
                        jp nz CComNA                    ; Not an arrow

                        ; Fire an arrow? More likely as we get closer to the thing...

;                        ld a,40                         ;
;                        call RandRange                  ;

                        ld a,(Seed+3)                   ; Rand 0..63
                        and $3F                         ;

                        ld d,(iy+dp_ErrM)               ; This is the range, I think
                        cp d                            ; dp_ErrM (Range?)
                        jr c CComNA                     ;

                        ld a,(ix+dm_nArrows)            ;
                        or a                            ;
                        jr z CComNA                     ;

                        ; We are firing an arrow

                        mAddNoise(3)                    ;

                        ; We're firing at the man, so he doesn't have a combat flag
                        ; Make sure we don't clear it

                        ld (iy+dp_pTarget2_H),0         ; If zero, no clearing

                        dec (ix+dm_nArrows)             ;

                        ld (iy+dp_Delay),ArrowSpeed     ;
                        ld (iy+dp_iDelay),ArrowSpeed    ;

                        ld a,(ix+dm_pMaze_L)            ;
                        ld (iy+dp_pMaze_L),a            ;

                        ld a,(ix+dm_pMaze_H)            ;
                        ld (iy+dp_pMaze_H),a            ;

                        ld l,(iy+dp_Step1_L)            ;
                        ld (iy+dp_Off_L),l              ;
                        ld h,(iy+dp_Step1_H)            ;
                        ld (iy+dp_Off_H),h              ;

                        ld a,l                          ;
                        and $1                          ;
                        xor $A1                         ;
                        ld (iy+dp_MissileChar),a        ;

                        ld (iy+dp_Life),ArrowLife       ;
                        call AllocateProjSpace          ; Make it active

                        ld hl,MoveArrow                 ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_BackingChar),0        ;

                        push ix                         ;

                        push iy                         ;
                        pop ix                          ;

                        call MoveArrow                  ;
                        pop ix                          ;

                        ret                             ; Done

                ; Now, use magic instead?

CComNA                  ld a,r                          ; 25% chance
                        and %0100100                    ;
                        ret nz                          ;

                        ; Might fire

                        ld a,(ix+dm_Magic)              ; Do we have enough magic?
                        cp 6                            ;
                        ret c                           ; Not enough

                        ; Make it more probable that the thing will fire if it has more magic

                        ld c,a                          ;

                        ld a,(Seed+2)                   ; Rand 0..15
                        and $0F                         ;

                        cp c                            ;
                        ret nc                          ; Rand > magic, ignore

                        ld a,(Seed+1)                   ; 7:8ths chance of a fireball
;                        and %01101000                   ;
                        and %00001000                   ;
                        jr nz,CComFire                  ; Fireball

                        ; Fire lightning

MonCelebrate2           mAddNoise(2)                    ;

                        ld hl,(pMan)                    ;
                        ld e,(ix+dm_pMaze_L)            ;
                        ld d,(ix+dm_pMaze_H)            ;
                        call InitLine                   ;

                        ld (iy+dp_MissileChar),$A0      ;
                        ld (iy+dp_Delay),LightSpeed     ;
                        ld (iy+dp_iDelay),LightSpeed    ;

                        ld hl,MoveLight                 ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_Life),LightLife       ;
                        call AllocateProjSpace          ; Make it active

                        ld (iy+dp_BackingChar),0        ;

                        ; We want a pointer to the owner's pointer to the maze.
                        ; so we can compare addresses to see if the projectile has hit its owner

                        ld a,ixl                        ; This is the address of the monster's pMaze
                        ld (iy+dp_pOwner_L),a           ;
                        ld a,ixh                        ;
                        ld (iy+dp_pOwner_H),a           ;

                        ld hl,pMan                      ;
                        ld (iy+dp_pTarget_L),l          ;
                        ld (iy+dp_pTarget_H),h          ;

                        ld a,(ix+dm_Magic)              ;
                        sub 6                           ;
                        ld (ix+dm_Magic),a              ;

                        ret                             ;

CComFire                ld a,(ix+dm_Magic)              ;
                        cp 10                           ;
                        ret c                           ;

                        mAddNoise(3)                    ;

                        ld hl,(pMan)                    ;
                        ld e,(ix+dm_pMaze_L)            ;
                        ld d,(ix+dm_pMaze_H)            ;
                        call InitLine                   ;

                        ld (iy+dp_Delay),FireSpeedInit  ;
                        ld (iy+dp_iDelay),FireSpeedInit ;

                        ld hl,MoveFire                  ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_Life),FireLife        ;
                        call AllocateProjSpace          ; Make it active

                        ld (iy+dp_BackingChar),0        ;
                        ld (iy+dp_MissileChar),$A4      ;

                        ; We want a pointer to the owner's pointer to the maze.
                        ; so we can compare addresses to see if the projectile has hit its owner

                        ld a,ixl                        ; This is the address of the monster's pMaze
                        ld (iy+dp_pOwner_L),a           ;
                        ld a,ixh                        ;
                        ld (iy+dp_pOwner_H),a           ;

                        ld hl,pMan                      ;
                        ld (iy+dp_pTarget_L),l          ;
                        ld (iy+dp_pTarget_H),h          ;

                        ld (iy+dp_ManF),0               ;
                        ld (iy+dp_UpdateRate),FireTurnRate;

                        ld hl,(pMan)                    ;
                        ld (iy+dp_TargetiPos_L),l       ;
                        ld (iy+dp_TargetiPos_H),h       ;

                        ld a,(ix+dm_Magic)              ;
                        sub 10                          ;
                        ld (ix+dm_Magic),a              ;

                        ret                             ;

                ; Steaming pile. Now, slow the animation down

MoveDeadMonster         ld a,(ix+dm_Char)               ; Is this a steaming thing?
                        cp $E0                          ;
                        jr nc ShowSteaming              ; No, it's not.

                        ; We're a static shape

                        ld (ix+dm_cSpeed),255           ; Slow updates

                        ; Show this static thing

ShowDeadThing           ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld (hl),a                       ;
                        ret                             ;

                ; It's steaming, slow down

ShowSteaming            ld c,(ix+dm_cSpeed)             ; Decrease the speed
                        inc c                           ;
                        jr z StopSteaming               ; Finished

                        ld (ix+dm_cSpeed),c             ; Slower

                        ; We're still growing deader...

                        inc a                           ;
                        and $E3                         ;
                        ld (ix+dm_Char),a               ;

                        ; Show it

                        jp ShowDeadThing                ; Show it

                ; We're completely dead

StopSteaming            ld a,$DB                        ; Burned out thing
                        ld (ix+dm_Char),a               ;
                        jp ShowDeadThing                ;

; Convert 8 directions (A) into bigmaze displacements (DE)

CDirect1                ld de,-129                      ;
                        cp 4                            ;
                        ret z                           ;

                        ld de,-127                      ;
                        cp 5                            ;
                        ret z                           ;

                        ld de,129                       ;
                        cp 6                            ;
                        ret z                           ;

                        ld de,127                       ;
                        cp 7                            ;
                        ret z                           ;

                        ; Convert 4 directions into bigmaze displacements

CDirect                 ld de,-128                      ;
                        cp 0                            ;
                        ret z                           ;

                        ld de,1                         ;
                        cp 1                            ;
                        ret z                           ;

                        ld de,128                       ;
                        cp 2                            ;
                        ret z                           ;

                        ld de,-1                        ;
                        cp 3                            ;
                        ret z                           ;

                        ld de,0                         ;
                        ret                             ;

; Simple random thing movement

MoveThingRandom         ld a,(ix+dm_Dirn)               ;
                        call CDirect1                   ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        add hl,de                       ;

                        ld a,(hl)                       ; Is this a door?
                        and $FE                         ;
                        cp $DC                          ;
                        call z MonODoor                 ; Yes, see if we want to open it

                        ld a,(hl)                       ;
                        cp ' '                          ;
                        jp nz MTR_NewDir_Hit            ; Hit something so change direction

                        ; It's clear so we move there

                        ld (ix+dm_pMaze_L),l            ;
                        ld (ix+dm_pMaze_H),h            ;

                        ld a,r                          ;
                        and $72                         ; Was $70
                        jp z MTR_NewDir                 ;

                        ret                             ;

                ; Type 1 monster new direction

MTR_NewDir_Hit          call MonKeep                    ; Want to keep this?
                        ret nc                          ; We did, exit

                        ; We didn't keep it, so change direction to a new random direction

MTR_NewDir              ld a,r                          ;
                        and $7                          ;
                        ld (ix+dm_Dirn),a               ;

                        ; Now, have we hit anything interesting?

                        ld a,(hl)                       ; Is this a sleeping monster or a ring?
                        cp cSleepingMonster             ; A sleeping monster?
                        call z Mon_HitSleeper           ; Yes, join it

                        and $F8                         ;
                        cp $88                          ;
                        call z Mon_HitRing              ; Yes, supercharge it

                        ld a,(hl)                       ; Hit a wall?
                        and $F0                         ;
                        cp $90                          ;
                        ret nz                          ; No, exit

                        ; Yes, and was this an alternative move for something else?

                        bit 6,(ix+dm_MoveType)          ;
                        ret z                           ; No, done

                        ; Yes, so we become a whatever it was again

                        res 6,(ix+dm_MoveType)          ;

                        ; Remember this position so we detect loops

MoveT2Mark              ld a,(ix+dm_pMaze_L)            ;
                        ld (ix+dm_PastPos_L),a          ;

                        ld a,(ix+dm_pMaze_H)            ;
                        ld (ix+dm_PastPos_H),a          ;

                        ld (ix+dm_TimeOut),0            ;
                        ret                             ;

; Wall follower one way

MoveThingWallFollowLHS  ld a,1                          ;
                        jp MTWF_1                       ;

MoveThingWallFollowRHS  ld a,-1                         ;

MTWF_1                  ld (WallFollowDirn),a           ;

                        ld a,(ix+dm_TimeOut)            ; Update the marker if we've not hit it for a while
                        or a                            ;
                        call z MoveT2Mark               ;

                        inc (ix+dm_TimeOut)             ; ++

                        ; Look the way we're moving

                        ld a,(ix+dm_Dirn)               ; This should only be LRUD
                        and $03                         ; Make sure
                        call CDirect                    ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        add hl,de                       ;

                        ; What's there?

                        ld a,(hl)                       ; Is this a ring or sleeping thing?
                        cp ' '                          ;
                        jr z MTWF_ClearInFront          ;

                        ; Hit something

                        cp cSleepingMonster             ; A sleeping monster?
                        call z Mon_HitSleeper           ; Yes, join it

                        and $F8                         ;
                        cp $88                          ;
                        call z Mon_HitRing              ; Yes, supercharge it

                        ; Not a ring, is it a door?

                        ld a,(hl)                       ; Is this a door?
                        and $FE                         ;
                        cp $DC                          ;
                        call z MonODoor                 ; Yes, see if we want to open it

                        ; We've hit something, try to keep it

                        call MonKeep                    ;
                        ret nc                          ;

                        ; Change direction?

                        ld a,[WallFollowDirn] 0         ; Dirn
                        ld e,(ix+dm_Dirn)               ; MoveType: 1-> -1 | 3-> +1
                        add a,e                         ;
                        and $3                          ; LRUD
                        ld (ix+dm_Dirn),a               ;

                        ; Detect loops

WallFC                  ld e,(ix+dm_PastPos_L)          ; Have we been here before?
                        ld d,(ix+dm_PastPos_H)          ;
                        or a                            ;
                        sbc hl,de                       ;
                        ret nz                          ; No, exit

                        ; We've been here before so start moving randomly

                        ld (ix+dm_TimeOut),1            ; Reset the time-out

                        set 6,(ix+dm_MoveType)          ; Assert the ALT-MOVE flag

                        ld a,r                          ; Move in a random diagonal direction
                        and $3                          ;
                        or $4                           ;
                        ld (ix+dm_Dirn),a               ;

                        ret                             ;

                ; It's clear in front, so check that we have a wall on out LHS

MTWF_ClearInFront       ld a,(WallFollowDirn)           ; Dirn
                        neg                             ;
                        ld e,(ix+dm_Dirn)               ; MoveType: 1-> -1 | 3-> +1
                        add a,e                         ; Change angle
                        and $3                          ; LRUD

                        call CDirect                    ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        add hl,de                       ;

                        ld a,(hl)                       ; Is this a door?
                        and $FE                         ;
                        cp $DC                          ;
                        call z MonODoor                 ; Yes, see if we want to open it

                        ; Is the left of us clear?

                        ld a,(hl)                       ;
                        cp ' '                          ;
                        jr nz MT_WallDoMoveDirn         ; No, we're OK

                        ; Yes, so move left

                        ld (ix+dm_pMaze_L),l            ;
                        ld (ix+dm_pMaze_H),h            ;

                        ; And change our direction

                        ld a,(WallFollowDirn)           ; Dirn
                        neg                             ;
                        ld e,(ix+dm_Dirn)               ; MoveType: 1-> -1 | 3-> +1
                        add a,e                         ; Change angle
                        and $3                          ; LRUD
                        ld (ix+dm_Dirn),a               ;

                        jp WallFC                       ;

                ; Still on the wall so just move

MT_WallDoMoveDirn       ld a,(ix+dm_Dirn)               ;
                        and $3                          ;
                        call CDirect                    ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        add hl,de                       ;
                        ld (ix+dm_pMaze_L),l            ;
                        ld (ix+dm_pMaze_H),h            ;

                        jp WallFC                       ;

                ; We've hit a ring. SUPERCHARGE!

Mon_HitRing             ld (ix+dm_cSpeed),25            ; Faster
                        ld (ix+dm_Magic),$FF            ; Fully armed
                        ld (ix+dm_Wounds),$FF           ; And hard to kill

                        ; Is this visible?

                        push hl                         ; See if it's on-screen
                        call SCVNew                     ;
                        pop hl                          ;

                        ret nc                          ; Yes, exit

                        ; We can't see this one at the moment, so go to sleep

                        ld (ix+dm_Char),cSleepingMonster; Go to sleep if we're not visible

                        ret                             ; Done

                ; We've hit another sleeper (don't alter a or hl)

Mon_HitSleeper          push hl                         ; See if it's on-screen
                        ld c,a                          ; Save a
                        push bc                         ;

                        call SCVNew                     ;

                        pop bc                          ; Restore
                        ld a,c                          ;
                        pop hl                          ;

                        ret nc                          ; Yes, exit

                        ld (ix+dm_Char),cSleepingMonster; Also goto sleep (presume we're invisible)

                        ld (ix+dm_cSpeed),45            ; Faster?
                        ld (ix+dm_Magic),$80            ; Fully armed
                        ld (ix+dm_Wounds),$80           ; And hard to kill

                        ret                             ; Done

; See if we want to keep this - preserve HL

MonKeep                 ld c,a                          ;
                        and $F0                         ;
                        cp $C0                          ;
                        jr z MonMagic                   ;

                        cp $B0                          ;
                        jr z MonTreas                   ;

                        scf                             ;
                        ret                             ;

MonMagic                ld a,c                          ;
                        and $F                          ;
                        ld c,a                          ;

                        ld a,(ix+dm_Magic)              ;
                        add a,c                         ;
                        add a,c                         ;
                        ret c                           ;

                        cp (ix+dm_MaxMagic)             ;
                        ccf                             ;
                        ret c                           ;

                        ld (ix+dm_Magic),a              ;

                        ld (hl),' '                     ; Kill it
                        or a                            ;
                        ret                             ;

MonTreas                ld a,(ix+dm_Treasure)           ;
                        cp 4                            ;
                        ccf                             ;
                        ret c                           ;

                        ; We have room, so store it

                        ld e,a                          ;
                        ld d,0                          ;

                        inc a                           ; ++
                        ld (ix+dm_Treasure),a           ;

                        push ix                         ;
                        add ix,de                       ;
                        ld (ix+dm_Cache),c              ;
                        pop ix                          ;

                        ld (hl),' '                     ; Kill it
                        or a                            ;
                        ret                             ;

; Move the projectiles - fast

MoveProjectiles         ld hl,[pNextProj] 0             ;

                        ld a,h                          ; End
                        or a                            ;
                        ret z                           ;

                        ld de,pNextProj-dp_pNext        ; Point at the head pointer as if it was a projectile
                        ld (pPrevProj),de               ;

                        push hl                         ;

MP_Next                 pop ix                          ;

                        ld a,ixh                        ;
                        or a                            ;
                        ret z                           ;

                        ld hl,(ix+dp_pNext)             ;
                        push hl                         ;

                        ld a,(ix+dp_Life)               ; Dead?
                        or a                            ;
                        jr z MP_Remove                  ; Yes, remove it

                        ; It's alive

                        dec (ix+dp_Delay)               ; Proj speed
                        jp nz MP_Alive                  ; Not time

                        ; So, move it

                        call MoveProj_IX                ; Move it

                        ; Now, if the life is zero, remove it from the list

                        ld a,(ix+dp_Life)               ; Dead?
                        or a                            ;
                        jr z MP_Remove                  ; Yes, remove it

                        ; Not dead.

MP_Alive                ld (pPrevProj),ix               ; Remember it
                        jp MP_Next                      ; Next

                        ; We want to remove this one

MP_Remove               ld iy,[pPrevProj] 0             ; Get the previous one's pointer

                        pop hl                          ; Get the next one
                        ld (iy+dp_pNext),hl             ; Remove this from the list
                        push hl                         ; Restore the stack

                        ; This one is dead, remove it

                        call FreeProjSpace_IX           ; Release it

                        jp MP_Next                      ;

                ; Move it

MoveProj_IX             ld a,(ix+dp_iDelay)             ; Set the speed
                        ld (ix+dp_Delay),a              ;

                        ld l,(ix+dp_pMaze_L)            ;
                        ld h,(ix+dp_pMaze_H)            ;

                        ld a,(ix+dp_Life)               ; Life --
                        dec a                           ;
                        ld (ix+dp_Life),a               ;
                        jr nz MProj3                    ;

                        ; We have timed-out. We need to release the combat flag on anything we're aimed at

                        call Proj_Clear_CombatFlag      ; Clear it

                        ld a,(ix+dp_BackingChar)        ; Is it drawn?
                        or a                            ;
                        ret z                           ; No, we're done

                        ; Clear it

                        ld (hl),' '                     ;

                        ret                             ;

                        ; Move a projectile

MProj3                  ld de,MProj4                    ;
                        push de                         ;

                        ld a,(ix+dp_BackingChar)        ;
                        or a                            ;
                        jr z MProj3A                    ;

                        ld (hl),' '                     ;

MProj3A                 ld l,(ix+dp_pCode_L)            ;
                        ld h,(ix+dp_pCode_H)            ;
                        jp (hl)                         ;

                ; After we've moved it

MProj4                  ld a,(ix+dp_Life)               ;
                        or a                            ;
                        ret z                           ;

                        ld l,(ix+dp_pMaze_L)            ;
                        ld h,(ix+dp_pMaze_H)            ;

                        ld a,(hl)                       ;
                        cp ' '                          ;
                        jr nz MProj4A                   ;

                        ld a,(ix+dp_MissileChar)        ;
                        ld (hl),a                       ;

                        ld (ix+dp_BackingChar),1        ;

                        ; We want to show this projectile, and make some noise while we're at it

                        ret                             ; Done

MProj4A                 ld (ix+dp_BackingChar),0        ;
                        ret                             ;

; Build the list of projectiles

InitProjList            ld b,nProj-1                    ;
                        ld iy,ProjList                  ;
                        ld hl,ProjList                  ;

                        ld (pFreeProj),hl               ; Start the list

                        ld de,lProj                     ; Length

IPL_Lp                  add hl,de                       ; Next
                        ld (iy+dp_pNext),hl             ; Link

                        push hl                         ;
                        pop iy                          ;

                        djnz IPL_Lp                     ; Do all but the last

                        ; This is the last one

                        ld hl,0                         ; Terminate the list
                        ld (iy+dp_pNext),hl             ; Link
                        ld (pNextProj),hl               ;

                        ret                             ; Done

; Find a projectile space (IY)

FindProjSpace           ld iy,[pFreeProj] 0             ;
                        ld a,iyh                        ;
                        or a                            ;
                        ret                             ;

; Add this proj to the active list

AllocateProjSpace       ld hl,(iy+dp_pNext)             ; Remove from free space
                        ld (pFreeProj),hl               ;

                        ld hl,(pNextProj)               ; Add to active list
                        ld (iy+dp_pNext),hl             ;
                        ld (pNextProj),iy               ;

                        ret                             ;

; Free this projectile

FreeProjSpace_IX        ld hl,(pFreeProj)               ; Add it to free space
                        ld (ix+dp_pNext),hl             ;
                        ld (pFreeProj),ix               ;

                        ; Remove it from the active list

                        ret                             ;

; Man fire an arrow

MFireArrow              ld hl,KeyArrowP                 ;
                        call ReadAKey                   ;
                        ret z                           ;

                        call FindProjSpace              ;
                        ret z                           ; Can't

                        push iy                         ;
                        pop ix                          ;

                        ld a,[ArrowCount] 0             ;
                        or a                            ;
                        ret z                           ;

                        dec a                           ;
                        ld (ArrowCount),a               ;

                        call AllocateProjSpace          ;

                        ld hl,(pMan)                    ;
                        ld a,[ArrDir] 0                 ;

                        call CDirect                    ;
                        cp 2                            ;
                        jr nz MFAr1                     ;

                        add hl,de                       ;
                        jp MFA0                         ;

MFAr1                   or a                            ;
                        jp z,MFA0                       ;

                        push af                         ;
                        push hl                         ;
                        pop iy                          ;
                        xor a                           ;
                        ex af,af'                       ;;;
                        xor a                           ;
                        ld (MFAr3B_SMC+2),a             ;
                        ld a,$80                        ;
                        ld (MFArOff1_SMC+2),a           ;

                        ld bc,128                       ;
                        add iy,bc                       ;

                        ld b,(ix+dp_Life)               ;
MFAr3                   add iy,de                       ;

MFArOff1_SMC            ld a,(iy-128)                   ;
                        and $FE                         ;
                        cp $DC                          ;
                        jr z,MFAr5                      ;

                        and $F8                         ;
                        cp $D0                          ;
                        jr z,MFAr5                      ;

                        and $F0                         ;
                        cp $90                          ;
                        jr nz,MFAr3B_SMC                ;

                        ex af,af'                       ;;
                        jr nz,MFAr5                     ;

                        or $FF                          ;
                        ex af,af'                       ;;
                        ld a,0                          ;
                        ld (MFArOff1_SMC+2),a           ;

MFAr3B_SMC              ld a,(iy)                       ;
                        and $FE                         ;
                        cp $DC                          ;
                        jr z,MFAr5                      ;

                        and $F8                         ;
                        cp $D0                          ;
                        jr z,MFAr7                      ;

                        and $F0                         ;
                        cp $90                          ;
                        jr nz,MFAr3A                    ;

                        ex af,af'                       ;;;
                        jr nz,MFAr5                     ;

                        or $FF                          ;
                        ex af,af'                       ;;;

                        ld a,$80                        ;
                        ld (MFAr3B_SMC+2),a             ;

MFAr3A                  djnz MFAr3                      ;

                        jr MFAr5                        ;

        ; We need to tell the emulator about this revolting code!

                        mem_smc MFArOff1_SMC+2,1        ;
                        mem_smc MFAr3B_SMC+2,1          ;

MFAr7                   ld bc,128                       ;
                        add hl,bc                       ;

MFAr5                   pop af                          ;

MFA0                    ld (ix+dp_Off_L),e              ;
                        ld (ix+dp_Off_H),d              ;
                        ld (ix+dp_pMaze_L),l            ;
                        ld (ix+dp_pMaze_H),h            ;
                        ld (ix+dp_BackingChar),0        ;
                        ld (ix+dp_Life),ArrowLifeMan    ;

                        ; Set the character

                        bit 0,a                         ;

                        ld a,$A0                        ;
                        jr nz MFA1                      ;

                        inc a                           ;

MFA1                    ld (ix+dp_MissileChar),a        ;

                        ld hl,MoveArrow                 ;
                        ld (ix+dp_pCode_L),l            ;
                        ld (ix+dp_pCode_H),h            ;

                        ld hl,$0505                     ;
                        ld (ix+dp_Delay),l              ;
                        ld (ix+dp_iDelay),h             ;

                        ld (ix+dp_pTarget2_H),0         ; Make sure we don't decrease the aim count

                        jp MoveProj_IX                  ;

MArr1                   ld (ix+dp_Life),0               ;
                        ret                             ;

MoveArrow               equ *                           ;

                        mNoiseON()                      ;

                        ld l,(ix+dp_pMaze_L)            ;
                        ld h,(ix+dp_pMaze_H)            ;
                        ld e,(ix+dp_Off_L)              ;
                        ld d,(ix+dp_Off_H)              ;
                        add hl,de                       ;
                        ld (ix+dp_pMaze_L),l            ;
                        ld (ix+dp_pMaze_H),h            ;

                        mNoiseOFF()                     ;

                        ld a,(hl)                       ;
                        cp ' '                          ;
                        ret z                           ;

                        and $FE                         ;
                        cp $DC                          ;
                        jr z MArr1                      ;

                        and $F0                         ;
                        cp $90                          ;
                        jr z MArr1                      ;

                        ld a,(hl)                       ;
                        and $F8                         ;
                        cp $D0                          ;
                        jp z ArrowHitMon                ;

                        cp $A8                          ;
                        ret nz                          ;

                        ld a,(ix+dp_Life)               ;
                        ld (ix+dp_Life),0               ; Kill the arrow
                        add a,25                        ;

                        sra a                           ;

                        ; Fall into...

HitMan                  ld b,a                          ; Save damage

        if def bNoDamage                                ;
                        ret                             ;
        endif                                           ;

                        ld a,(Wounds)                   ; Add it to the wounds
                        add a,b                         ;
                        ld (Wounds),a                   ;

                        ; High enough wounds to kill the man?

                        cp MaxWounds                    ; Dead yet?
                        ret c                           ; No, exit

                        ; By rights we're dead, but we will try healing...

HM_TryToHeal            call TryToHeal                  ; Try healing before we die
                        jr c HM_NoMagic                 ;

                        ; We healed, but was it enough?

                        ld a,(Wounds)                   ; Add it to the wounds
                        cp MaxWounds                    ; Still dead?
                        jp nc HM_TryToHeal              ; Yes, try healing again

                        ; We're alive now

                        ret                             ; Done

; We don't have enough magic to heal more

HM_NoMagic              ld a,(Wounds)                   ; Add it to the wounds
                        cp MaxWounds                    ; Still dead?
                        ret c                           ; Nope, done

                        ; Are we dead already?

                        ld a,(GameBType)                ; Dead
                        or a                            ;
                        ret m                           ; Yes, done

                        ; This is the process of killing the player

                        ; Now, if he's near a wall we need to move X

                        ld hl,(pMan)                    ; Get his position
                        ld de,128                       ;

                        ld (hl),' '                     ; Clear it
                        add hl,de                       ;
                        ld (hl),' '                     ; Clear it
                        ld de,-127                      ; Move back to head + 1 space to the right
                        add hl,de                       ;

                        ld a,(hl)                       ;
                        and $FE                         ; Door?
                        cp $DC                          ;
                        jr z HM_DeadMove                ; Yes, move

                        and $F0                         ;
                        cp $90                          ;
                        jr nz HM_PosOK                  ;

                        ; We can't leave him here, move him left

HM_DeadMove             dec l                           ;
                        dec l                           ;
                        ld (pMan),hl                    ;

HM_PosOK                ld hl,(pMan)                    ;
                        ld a,$A8                        ; Any man char
                        ld (hl),a                       ; Put it where his head is
                        inc l                           ;
                        ld (hl),a                       ; Put it where his feet are

                        ld a,%1 0000000                 ; Dead flag+time-out count
                        ld (GameBType),a                ; Yes

                        ; Remove the sodding sword

                        xor a                           ; Clear it
                        ld (SwdPhase),a                 ;

                        jp MSDoing                      ; Remove the sword, if necc.

; Man hit by a fireball

HitManFire              ld (ix+dp_Life),0               ; Kill the fireball

                        ld a,15                         ;
                        jr HitMan                       ;

; Man hit by lightning

HitManLight             ld a,10                         ;
                        jr HitMan                       ;

; Arrow [ix] hit monster

ArrowHitMon             ld a,70                         ;
                        ld b,$DF                        ;
                        ld (ix+dp_Life),0               ;

                        ; We've hit a monster at [hl] A = Damage, B = dead thing character.

HitMonster              ld c,a                          ;
                        ld a,b                          ;
                        ld (TempStore),a                ;

                        ld iy,MonsterList               ;
                        ld de,lMonst                    ;

                        ld b,nMonst                     ;

HMon1                   ld a,(iy+dm_pMaze_L)            ;
                        cp l                            ;
                        jp nz HMonNope                  ;

                        ld a,(iy+dm_pMaze_H)            ;
                        cp h                            ;
                        jr z HitThisMon                 ;

HMonNope                add iy,de                       ;
                        djnz HMon1                      ;

                        ; We haven't found this monster...

                        ld a,1                          ; Blue border
                        out ($FE),a                     ;

                        ret                             ; Ignore the problem???

                ; We've hit this one hl = pMaze

HitThisMon              ld a,(iy+dm_Wounds)             ;
                        sub c                           ;
                        ld (iy+dm_Wounds),a             ;

                        ret nc                          ; Not dead

                        ; Now, can it heal?

        if enabled optMonstersHeal
                        ld c,(iy+dm_Magic)              ;
                        add a,c                         ;
                        ld (iy+dm_Magic),a              ;
                        ret p                           ;
        endif
                        ; Can't kill anything after we're dead

                        ld a,(GameBType)                ; Ignore if the player is dead
                        or a                            ;
                        ret m                           ;

                        ; We've killed this one

                        ld (iy+dm_Flags),$FF            ;

                        ld a,(TempStore)                ;
                        ld (hl),a                       ;
                        ld (iy+dm_Char),a               ;

                        ld a,(iy+dm_iSpeed)             ;
                        ld (iy+dm_cSpeed),a             ;

                        ; We have another dead thing

                        ld hl,(nDTs)                    ; Count++
                        inc hl                          ;
                        ld (nDTs),hl                    ;

                        ret                             ;

; Setup to draw a line from DE to HL. Breshenhams... (Martin did this, I think)

InitLine                call ConvBM_To_XY_HL            ;

                        ; This is for when HL is already XY

InitLine_HLisXY         ld (iy+dp_pMaze_L),e            ;
                        ld (iy+dp_pMaze_H),d            ;
                        ld (iy+dp_dX),1                 ;
                        ld (iy+dp_dY),1                 ;

                        ex de,hl                        ;
                        call ConvBM_To_XY_HL            ;
                        ex de,hl                        ;

                        ld a,l                          ;
                        sub e                           ;
                        ld l,a                          ;
                        jp z ILine1A                    ;
                        jp p ILine1                     ;

                        neg                             ;
                        ld (iy+dp_dX),-1                ;

ILine1                  ld e,a                          ;
                        ld a,h                          ;
                        sub d                           ;
                        ld h,a                          ;
                        jp z ILine2A                    ;
                        jp p ILine2                     ;

                        neg                             ;
                        ld (iy+dp_dY),-1                ;

ILine2                  ld d,a                          ;
                        sub e                           ;
                        jr nc ILine3                    ;

                        ; dX > dY

                        ld (iy+dp_Life),e               ;
                        ld (iy+dp_ErrM),e               ;
                        sra e                           ;
                        ld (iy+dp_ErrR),e               ;
                        ld (iy+dp_ErrS),d               ;

                        call ILine4                     ;

                        ld (iy+dp_Off_L),l              ;
                        ld (iy+dp_Off_H),h              ;
                        ld (iy+dp_dY),0                 ;

                        call ILine4                     ;

                        ld (iy+dp_Step1_L),l            ;
                        ld (iy+dp_Step1_H),h            ;
                        ret                             ;

                        ; dY > dX

ILine3                  ld (iy+dp_Life),d               ;
                        ld (iy+dp_ErrM),d               ;
                        sra d                           ;
                        ld (iy+dp_ErrR),d               ;
                        ld (iy+dp_ErrS),e               ;

                        call ILine4                     ;

                        ld (iy+dp_Off_L),l              ;
                        ld (iy+dp_Off_H),h              ;
                        ld (iy+dp_dX),0                 ;

                        call ILine4                     ;

                        ld (iy+dp_Step1_L),l            ;
                        ld (iy+dp_Step1_H),h            ;
                        ret                             ;

ILine1A                 ld (iy+dp_dX),0                 ;
                        jr ILine1                       ;

ILine2A                 ld (iy+dp_dY),0                 ;
                        jr ILine2                       ;

                        ; dX/dY -> offset in HL

ILine4                  ld a,(iy+dp_dX)                 ;
                        cp -1                           ;
                        jr z ILine4A                    ;

                        ld a,(iy+dp_dY)                 ;
                        cp -1                           ;
                        jr z ILine4B                    ;

                        ; dX = 0/1 dY = 0/1

                        ld l,(iy+dp_dX)                 ; l = 0/1 (crem)
                        inc l                           ; l := 1 or 2
                        ld h,a                          ; h= 0/1
                        srl h                           ; >>
                        rr l                            ; >>
                        ret                             ;

                        ; dX = -1

ILine4A                 ld a,(iy+dp_dY)                 ;
                        cp -1                           ;
                        jr z ILine4AA                   ;

                        or a                            ;
                        jr z ILine4AB                   ;

                        ; dX = -1, dY = +1

                        ld hl,127                       ;
                        ret                             ;

ILine4AA                ld hl,-129                      ;
                        ret                             ;

ILine4AB                ld hl,-1                        ;
                        ret                             ;

ILine4B                 ld a,(iy+dp_dX)                 ;
                        ld hl,-128                      ;
                        or l                            ;
                        ld l,a                          ;
                        ret                             ;

; Mustn't alter BC

NextPoint               ld a,(iy+dp_Life)               ; 0?
                        or a                            ;
                        ccf                             ;
                        ret z                           ; Yes (CF)

                        dec a                           ;
                        ld (iy+dp_Life),a               ;

                        ; Calc next point

                        ld l,(iy+dp_pMaze_L)            ;
                        ld h,(iy+dp_pMaze_H)            ;

                        ld a,(iy+dp_ErrR)               ;
                        sub (iy+dp_ErrS)                ;
                        ld (iy+dp_ErrR),a               ;
                        jp p NextPoint1                 ;

                        ld e,(iy+dp_Off_L)              ;
                        ld d,(iy+dp_Off_H)              ;
                        add hl,de                       ;
                        ld (iy+dp_pMaze_L),l            ;
                        ld (iy+dp_pMaze_H),h            ;

                        ld a,(iy+dp_ErrR)               ;
                        add a,(iy+dp_ErrM)              ;
                        ld (iy+dp_ErrR),a               ;

                        or a                            ;
                        ret                             ;

NextPoint1              ld e,(iy+dp_Step1_L)            ;
                        ld d,(iy+dp_Step1_H)            ;
                        add hl,de                       ;
                        ld (iy+dp_pMaze_L),l            ;
                        ld (iy+dp_pMaze_H),h            ;

                        or a                            ;
                        ret                             ;

; Look for the nearest monster HL = position, A =  angle?? C = search range

MonsterSearch           ld ix,MonsterList               ; Make the first one the putative monster

                        ld a,$FF                        ;
                        ld (MonSAimCnt),a               ;

                        ld b,nMonst                     ;

MonSearchLoop           bit 7,(ix+dm_Flags)             ; Alive?
                        jr nz,MonSNext                  ; No, skip

;                        bit 7,(ix+dm_Combat)            ; Already targetted?
;                        jr nz MonSNext                  ; Yes, ignore it

                        ld l,(ix+dm_pMaze_L)            ; Target
                        ld h,(ix+dm_pMaze_H)            ;

                        ld de,(pMan)                    ; Src

                        push bc                         ; Save
                        call RangeLook                  ; And look
                        pop bc                          ; Restore

                        jr c,MonSNext                   ; Not visible, skip

                        ; This monster is visible, d = range

                        ld a,[MonSAimCnt] 0             ; Has it been aimed at less?
                        ld e,(ix+dm_AimCnt)             ;
                        cp e                            ;
                        jr c MonSNext                   ;

                        ; This one is nearer (or the same)

                        ld a,e                          ;
                        ld (MonSAimCnt),a               ;

                        ld (pNearMonster),ix            ;

;                        ld d,(iy+dp_ErrM)               ; Get the distance
;                        ld (MonSRange),a                ;

                        ; Look at the next monster

MonSNext                ld de,lMonst                    ;
                        add ix,de                       ;

                        djnz MonSearchLoop              ;

                        ; Return the range to this monster

                        ld a,(MonSAimCnt)               ;
                        add a,1                         ;

                        ret                             ;

; NC means we can see the man, maybe through a door

RangeDoor               push de                         ;

                        ; QAD check for the range first

                        call ConvBM_To_XY_HL            ;
                        ex de,hl                        ;
                        call ConvBM_To_XY_HL            ;
                        ld a,e                          ;
                        sub l                           ;
                        jp p,RD1                        ;

                        neg                             ; See if dX
RD1                     cp c                            ;
                        jp p,RLFail_S                   ; dX > C

                        ld a,d                          ;
                        sub h                           ;
                        jp p,RD2                        ;

                        neg                             ;
RD2                     cp c                            ;
                        jp p,RLFail_S                   ; dY > C

                        ex de,hl                        ;
                        pop de                          ;

                        ; Now, it's in range, so draw the line

                        xor a                           ;
                        ld (DoorFlag),a                 ;

                        ; Now, it's in range, so draw the line

                        call InitLine_HLisXY            ;

                        ; Move to the first point on the line

                        call NextPoint                  ;
                        ccf                             ;
                        ret nc                          ; Done, exit

                        ; First point on the line. Is it a door?

                        ld a,(hl)                       ;
                        and $FE                         ;
                        cp $DC                          ;
                        jr z,RDFDoor                    ; Door

                        and $F0                         ;
                        cp $90                          ;
                        jr z,RLFail                     ; Wall

                        ; We've done the first point, do the rest

                        jp RL_Lp                        ; As below

                        ; Door

RDFDoor                 ld (DoorFlag),a                 ;

                        jp RL_Lp                        ; Next

; DE = src, HL = target, c = max range
; Used to return d=dp_ErrM (range), but doesn't now...

RangeLook               push de                         ;

                        call ConvBM_To_XY_HL            ;
                        ex de,hl                        ;
                        call ConvBM_To_XY_HL            ;
                        ld a,e                          ;
                        sub l                           ;
                        jp p,RL1                        ;

                        neg                             ; See if dX
RL1                     cp c                            ;
                        jp p,RLFail_S                   ; dX > C

                        ld a,d                          ;
                        sub h                           ;
                        jp p,RL2                        ;

                        neg                             ;
RL2                     cp c                            ;
                        jp p,RLFail_S                   ; dY > C

                        ex de,hl                        ;
                        pop de                          ;

                        ; Now, it's in range, so draw the line

                        call InitLine_HLisXY            ;

                        ; Look along the line

RL_Lp                   call NextPoint                  ;
                        ccf                             ;
                        ret nc                          ; Done, exit

                        ; Any point on the line

                        ld a,(hl)                       ; Get the char

                        and $FE                         ;
                        cp $DC                          ;
                        scf                             ;
                        ret z                           ; Hit a door

                        and $F0                         ; Wall?
                        cp $90                          ;
                        jp nz RL_Lp                     ; No, loop

                        ; Failed

RLFail                  scf                             ;
                        ret                             ;

RLFail_S                pop de                          ;

                        scf                             ;
                        ret                             ;

; See if we want to fire a fireball

FireBall                ld hl,KeyFireP                  ;
                        call ReadAKey                   ;
                        ret z                           ;

                        call FindProjSpace              ;
                        ret z                           ;

                        ld a,(CurrentMagic)             ; Enough magic?
                        sub 2                           ;
                        ret c                           ;

                        mAddNoise(1)                    ;

                        ld c,FBSR                       ;

                        call MonsterSearch              ;
                        ld (iy+dp_Life),0               ; Kill it
                        ret c                           ; Nothing to fire at

                        ; We have a target

                        ld ix,[pNearMonster] 0          ; HL = target
                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;

                        ld de,(pMan)                    ; DE = Source

                        ld a,(CurrentMagic)             ; Dec the magic
                        sub 2                           ;
                        ld (CurrentMagic),a             ;

                        set 7,(ix+dm_Combat)            ;
                        inc (ix+dm_AimCnt)              ;
                        call InitLine                   ;

                        ld hl,MoveFire                  ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_MissileChar),$A4      ;

                        ld (iy+dp_Delay),FireSpeedInit  ;
                        ld (iy+dp_iDelay),FireSpeedInit ;

                        ld (iy+dp_BackingChar),0        ;
                        ld (iy+dp_Life),FireLife        ;
                        call AllocateProjSpace          ;

                        ; The address of the man's pMaze

                        ld hl,pMan                      ;
                        ld (iy+dp_pOwner_L),l           ;
                        ld (iy+dp_pOwner_H),h           ;

                        ld a,ixl                        ;
                        ld (iy+dp_pTarget_L),a          ;
                        ld (iy+dp_pTarget2_L),a         ;
                        ld a,ixh                        ;
                        ld (iy+dp_pTarget_H),a          ;
                        ld (iy+dp_pTarget2_H),a         ;

                        ld (iy+dp_ManF),1               ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld (iy+dp_TargetiPos_L),l       ;
                        ld (iy+dp_TargetiPos_H),h       ;

                        ld (iy+dp_UpdateRate),FireTurnRate;
                        ret                             ;

; Man hit by fireball

MFire1                  ld (ix+dp_Life),0               ; Kill the fireball

                        ; We must clear the combat flag on the target of this projectile

Proj_Clear_CombatFlag   ld d,(ix+dp_pTarget2_H)         ; Get the Target2 pointer
                        dec d                           ; 0?
                        inc d                           ;
                        ret z                           ; Yes, ignore it

                        ; We presume the pointer is valid

                        ld e,(ix+dp_pTarget2_L)         ;

                        ld (ix+dp_pTarget2_H),0         ; Don't do this twice

                        ; Assuming this is a thing we clear its combat flag

                        push hl                         ; Save

                        ld hl,dm_Combat                 ; Move to it
                        add hl,de                       ;

                        res 7,(hl)                      ; Clear it

                        add hl,dm_AimCnt-dm_Combat      ; Move to it

                        dec (hl)                        ; Reduce it

                        pop hl                          ;
                        ret                             ;

MoveFire                ld a,(ix+dp_Life)               ;
                        inc a                           ;
                        ld (ix+dp_Life),a               ;

                        and $3                          ;
                        or $A4                          ;
                        ld (ix+dp_MissileChar),a        ;

                        push ix                         ;
                        pop iy                          ;
                        dec (iy+dp_UpdateRate)          ;
                        jr nz MoveFireTM1               ;

                        ; Time to update

                        ld a,(iy+dp_iDelay)             ;
                        dec a                           ;
                        cp FireSpeedFast+1              ;
                        jr c MF_NSU                     ;

                        ld (iy+dp_iDelay),a             ;

MF_NSU                  mNoiseON()                      ;

                        ld (iy+dp_UpdateRate),FireTurnRate ;

                        ld l,(iy+dp_pTarget_L)          ;
                        ld h,(iy+dp_pTarget_H)          ;
                        ld e,(hl)                       ;
                        inc hl                          ;
                        ld d,(hl)                       ;
                        ld l,(iy+dp_TargetiPos_L)       ;
                        ld h,(iy+dp_TargetiPos_H)       ;

                        mNoiseOFF()                     ;

                        or a                            ;
                        sbc hl,de                       ;
                        jp nz MoveFireTM                ; It has moved

                        ; Move along the current line

MoveFireTM1             call NextPoint                  ;
                        jr c MFire1                     ;

                        ld a,(hl)                       ;
                        cp ' '                          ;
                        ret z                           ;

                        and $FE                         ;
                        cp $DC                          ;
                        jr z MFire1                     ;

                        and $F0                         ;
                        cp $90                          ;
                        jr z MFire1                     ;

                        ld a,(hl)                       ;
                        and $F8                         ;
                        cp $D0                          ;
                        jr z HFireMon                   ;

                        cp $A8                          ; Is this the man?
                        ret nz                          ; No, exit

                        ; We have hit the man

                        ld a,(iy+dp_ManF)               ; Was this fired by a monster?
                        or a                            ;
                        jp z HitManFire                 ; Yes, hit him

                        ; No, it was fired by the man

                        ld a,FireLife                   ; In the first few moves?
                        sub (iy+dp_Life)                ;
                        cp ManDodgeTime                 ;
                        ret c                           ; Yes, ignore

                        ; We should have dodged. Hit him...

                        jp HitManFire                   ;

                        ; We want to try to aim again

MoveFireTM              ld a,(iy+dp_Life)               ;
                        push af                         ;

                        ld (iy+dp_TargetiPos_L),e       ;
                        ld (iy+dp_TargetiPos_H),d       ;
                        ld l,(iy+dp_pMaze_L)            ;
                        ld h,(iy+dp_pMaze_H)            ;
                        ex de,hl                        ;

                        call InitLine                   ;

                        ld hl,MoveFire                  ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        pop af                          ;
                        ld (iy+dp_Life),a               ;

                        jp MoveFireTM1                  ;

                        ; We've hit a monster. But is it the one that fired this in the first place?

HFireMon                ld a,(iy+dp_ManF)               ; Was this fired by the man?
                        or a                            ;
                        jp nz HitMonFire                ; Yes, so cause damage.

                        ; See if it has shot itself

                        ld e,(iy+dp_pOwner_L)           ; Get the owner's pMaze address
                        ld d,(iy+dp_pOwner_H)           ; Get the owner's pMaze address
                        ld a,(de)                       ; LSB of the owner's pMaze
                        cp l                            ; Same as this location?
                        jp nz HitMonFire                ; Nope, hit it

                        inc de                          ;
                        ld a,(de)                       ; MSB of the owner's pMaze
                        cp h                            ; Same as this location?
                        jp nz HitMonFire                ; Nope, hit it

                        ; Is it in the first few moves?

                        ld a,FireLife                   ;
                        sub (iy+dp_Life)                ;
                        cp DodgeTime                    ;
                        ret c                           ; Yes, so don't cause damage

                        ; No, so damage it

HitMonFire              ld a,FireDamageToMon            ;
                        ld b,$E0                        ;
                        call MFire1                     ;

                        jp HitMonster                   ;

; Should we try lightning?

Lightning               ld a,[ManLightDel] 0            ; Delay between firing?
                        or a                            ;
                        ret nz                          ;

                        ld a,[GameMode] 0               ; Fire if we're in a running game
                        cp IsRunning                    ;
                        jr z LightFire                  ;

                        ld a,(KeyLight)                 ; Or if this is NZ
                        or a                            ;
                        ret z                           ;

                        ; Fire

LightFire               call FindProjSpace              ;
                        ret z                           ;

                        ld c,XW+7                       ; Shorter viewing distance
                        ld a,(GameMode)                 ; No cost if this is a running game
                        cp IsRunning                    ;
                        jr z ManLight1                  ;

                        ld a,(CurrentMagic)             ;
                        sub 1                           ;
                        ret c                           ;

                        ld c,LtSR                       ;

ManLight1               call MonsterSearch              ;
                        ld (iy+dp_Life),0               ;
                        ret c                           ;

                        ld ix,(pNearMonster)            ;
                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld de,(pMan)                    ;

                        inc (ix+dm_AimCnt)              ; We're firing at it

                        mAddNoise(1)                    ;

                        ld a,(GameMode)                 ; No cost if this is a running game
                        cp IsRunning                    ;
                        jr z ManLight2                  ;

                        ld a,(CurrentMagic)             ;
                        dec a                           ;
                        ld (CurrentMagic),a             ;

ManLight2               call InitLine                   ;

                        ld hl,MoveLight                 ;
                        ld (iy+dp_pCode_L),l            ;
                        ld (iy+dp_pCode_H),h            ;

                        ld (iy+dp_MissileChar),$A2      ;
                        ld (iy+dp_BackingChar),0        ;

                        ld hl,(LightLife << 8) + LightSpeed ; Running game lifetime

                        ld a,(GameMode)                 ; Use these if not a running game
                        cp IsRunning                    ;
                        jr nz ManLight3                 ;

                        ld hl,(LightLifeRunning << 8) + LightSpeedRunning ; Running game lifetime

ManLight3               ld (iy+dp_Life),h               ;
                        ld (iy+dp_Delay),l              ;
                        ld (iy+dp_iDelay),l             ;

                        call AllocateProjSpace          ;

                        ld hl,pMan                      ;
                        ld (iy+dp_pOwner_L),l           ;
                        ld (iy+dp_pOwner_H),h           ;

                        ld a,ixl                        ;
                        ld (iy+dp_pTarget_L),a          ;
                        ld (iy+dp_pTarget2_L),a         ;
                        ld a,ixh                        ;
                        ld (iy+dp_pTarget_H),a          ;
                        ld (iy+dp_pTarget2_H),a         ;

                        ld (iy+dp_ManF),1               ;

                        ld l,(ix+dm_pMaze_L)            ;
                        ld h,(ix+dm_pMaze_H)            ;
                        ld (iy+dp_TargetiPos_L),l       ;
                        ld (iy+dp_TargetiPos_H),h       ;

                        ld b,4                          ;
                        ld a,(GameMode)                 ; Faster repeat rate in the running game
                        cp IsRunning                    ;
                        jr nz MLSetFireRate             ;

                        ld b,2                          ; Faster

MLSetFireRate           ld a,b                          ; 4 or 2
                        ld (ManLightDel),a              ;

                        ret                             ;

MoveLight               inc (ix+dp_Life)                ;

                        ld a,r                          ; Random sparkle
                        and $01                         ;
                        or $A2                          ;

                        ld (ix+dp_MissileChar),a        ;

MoveCelebrate           push ix                         ;
                        pop iy                          ;

                        ld a,(iy+dp_ErrR)               ;
                        ld (iy+dp_RSave),a              ;
                        ld a,(iy+dp_pMaze_L)            ;
                        ld (iy+dp_pMazeSave_L),a        ;
                        ld a,(iy+dp_pMaze_H)            ;
                        ld (iy+dp_pMazeSave_H),a        ;

                        ; Move to next point

                        ld a,4                          ; We're allowed to bounce 4 times (prevents lock-up)
                        ld (LightBounceCnt),a           ;

MLRf0                   ld a,[LightBounceCnt] 0         ; Dec this
                        dec a                           ;
                        jr z ML_Kill                    ; Kill it
                        ld (LightBounceCnt),a           ;

                        call NextPoint                  ;
                        ret c                           ;

                        ld a,(hl)                       ;
                        cp ' '                          ;
                        ret z                           ;

                        and $FE                         ;
                        cp $DC                          ;
                        jp z MLightRefl                 ;

                        and $F0                         ;
                        cp $90                          ;
                        jp z MLightRefl                 ;

                        cp $C0                          ; Hit magic
                        jr z MLightHitMagic             ; Skip if so

                        ld a,(hl)                       ;
                        and $F8                         ;
                        cp $D0                          ;
                        jr z HLightMon                  ;

                        cp $A8                          ; Man character?
                        ret nz                          ;

                        ; We have hit the man

                        ld a,(iy+dp_ManF)               ; Was this fired by a monster?
                        or a                            ;
                        jp z HitManLight                ; Yes, hit him

                        ; No, it was fired by the man

                        ld a,(GameMode)                 ; We ignore this if in the running game
                        cp IsRunning                    ;
                        ret z                           ;

                        ; In a normal game we hurt after the start

                        ld a,LightLife                  ; In the first few moves?
                        sub (iy+dp_Life)                ;
                        cp ManDodgeTime                 ;
                        ret c                           ; Yes, ignore

                        ; We should have dodged. Hit him...

                        jp HitManLight                  ;

MLightHitMagic          ld a,(hl)                       ; Inc it
                        inc a                           ;
                        cp $D0                          ; Overflow
                        ret z                           ; Don't make it a monster ;)
                        ld (hl),a                       ;

                        ret                             ; Done

ML_Kill                 ld (iy+dp_Life),0               ; Kill it
                        ret                             ;

        ; We've hit a monster at BigMaze (hl). But is it the one that fired this in the first place?

HLightMon               ld a,(iy+dp_ManF)               ; Was this fired by the man?
                        or a                            ;
                        jp nz HitMonLight               ; Yes, so cause damage.

                        ; See if it has shot itself

                        ld e,(iy+dp_pOwner_L)           ; Get the owner's pMaze address
                        ld d,(iy+dp_pOwner_H)           ; Get the owner's pMaze address
                        ld a,(de)                       ; LSB of the owner's pMaze
                        cp l                            ; Same as this location?
                        jp nz HitMonLight               ; Nope, hit it

                        inc de                          ;
                        ld a,(de)                       ; MSB of the owner's pMaze
                        cp h                            ; Same as this location?
                        jp nz HitMonLight               ; Nope, hit it

                        ; Is it in the first three moves?

                        ld a,LightLife                  ;
                        sub (iy+dp_Life)                ;
                        cp DodgeTime                    ;
                        ret c                           ; Yes, so don't cause damage

                        ; No, so damage the thing at BigMaze (hl)

HitMonLight             ld a,LightDamageToMon           ;
                        ld b,$E0                        ;
                        jp HitMonster                   ;

MLightRefl              mNoiseON()                      ;

                        ld a,(iy+dp_RSave)              ;
                        ld (iy+dp_ErrR),a               ;

                        ld e,(iy+dp_pMazeSave_L)        ;
                        ld (iy+dp_pMaze_L),e            ;
                        ld d,(iy+dp_pMazeSave_H)        ;
                        ld (iy+dp_pMaze_H),d            ;

                        inc (iy+dp_Life)                ;

                        ld l,(iy+dp_Step1_L)            ;
                        ld h,(iy+dp_Step1_H)            ;
                        add hl,de                       ;

                        mNoiseOFF()                     ;

                        call TestWall                   ;
                        jp nz MLRf1                     ;

                        ld l,(iy+dp_Step1_L)            ;
                        ld h,(iy+dp_Step1_H)            ;
                        push de                         ;
                        ld de,0                         ;
                        ex de,hl                        ;
                        or a                            ;
                        sbc hl,de                       ;
                        ld (iy+dp_Step1_L),l            ;
                        ld (iy+dp_Step1_H),h            ;
                        pop de                          ;

MLRf1                   ld a,(iy+dp_ErrS)               ;
                        or a                            ;
                        jp z MLRf0                      ;

                        xor a                           ;
                        ex af,af'                       ;;;
                        ld l,(iy+dp_Off_L)              ;
                        ld h,(iy+dp_Off_H)              ;

                        push hl                         ;
                        call Separate                   ;
                        ex (sp),hl                      ;
                        call RTest2                     ;
                        pop bc                          ;
                        call RTest2                     ;

                        ld (iy+dp_Off_L),l              ;
                        ld (iy+dp_Off_H),h              ;
                        ex af,af'                       ;;;
                        or a                            ;
                        jp nz,MLRf0                     ;

                        ld e,(iy+dp_Off_L)              ;
                        ld d,(iy+dp_Off_H)              ;
                        ld hl,0                         ;
                        or a                            ;
                        sbc hl,de                       ;

                        ld (iy+dp_Off_L),l              ;
                        ld (iy+dp_Off_H),h              ;
                        ld e,(iy+dp_Step1_L)            ;
                        ld d,(iy+dp_Step1_H)            ;
                        ld hl,0                         ;
                        or a                            ;
                        sbc hl,de                       ;
                        ld (iy+dp_Step1_L),l            ;
                        ld (iy+dp_Step1_H),h            ;

                        jp MLRf0                        ;

TestWall                ld a,(hl)                       ;

                        and $FE                         ;
                        cp $DC                          ;
                        ret z                           ;

                        and $F0                         ;
                        cp $90                          ;
                        ret                             ;

RTest2                  push hl                         ;

                        ld h,b                          ;
                        ld l,c                          ;

                        add hl,de                       ;
                        call TestWall                   ;

                        pop hl                          ;
                        ret nz                          ;

                        or a                            ;
                        sbc hl,bc                       ;

                        or a                            ;
                        sbc hl,bc                       ;

                        ld a,1                          ;

                        ex af,af'                       ;;;
                        ret                             ;

Separate                bit 7,h                         ;

                        ld bc,-128                      ;
                        jr nz,Sep1                      ;

                        ld bc,128                       ;

Sep1                    bit 6,l                         ;
                        ld hl,-1                        ;

                        jr nz,Sep2                      ;

                        ld hl,1                         ;
Sep2                    ret                             ;

; See if QUIT is pressed (Z if so)

CheckQuit               ld bc,zeuskeyaddr("QT")         ; Q&T
                        in a,(c)                        ;
                        xor inv zeuskeymask("QT")       ;
                        and %000 1 1 1 1 1              ;
                        ret nz                          ;

                        ld bc,zeuskeyaddr("UI")         ; U&I
                        in a,(c)                        ;
                        xor inv zeuskeymask("UI")       ;
                        and %000 1 1 1 1 1              ;
                        ret                             ;

; See if JOKE is pressed (Z if so)

CheckJOKE               ld bc,zeuskeyaddr("JK")         ; J&K
                        in a,(c)                        ;
                        xor inv zeuskeymask("JK")       ;
                        and %000 1 1 1 1 1              ;
                        ret nz                          ;

                        ld bc,zeuskeyaddr("E")          ; E
                        in a,(c)                        ;
                        xor inv zeuskeymask("E")        ;
                        and %000 1 1 1 1 1              ;
                        ret nz                          ;

                        ld bc,zeuskeyaddr("O")          ; O
                        in a,(c)                        ;
                        xor inv zeuskeymask("O")        ;
                        and %000 1 1 1 1 1              ;
                        ret                             ;

; Scan the keys every other time we're called

GameScanKeys            ld a,(KeyFlag)                  ;
                        inc a                           ;
                        ld (KeyFlag),a                  ;

                        and 1                           ;
                        ret nz                          ;

                        call MMoveLR_Scan               ;
                        push af                         ;
                        pop hl                          ;
                        ld (LRKeys),hl                  ;

                        call MMoveUD_Scan               ;
                        push af                         ;
                        pop hl                          ;
                        ld (UDKeys),hl                  ;

                        ; Is this the alternate arrangement?

                        ld a,(DType)                    ; Get the flag
                        or a                            ;
                        jp nz GSK_Alternate             ; Skip

                        ; Standard layout

mDefineKey              macro(Key,Label)
                          ld bc,zeuskeyaddr(Key)        ;
                          in a,(c)                      ;
                          and zeuskeymask(Key)          ;
                          ld hl,Label                   ;
                          call DWKey                    ;
                          mend

mDefineKeyPlusJoy       macro(Key,Label,JoyBit)
                          ld bc,zeuskeyaddr(Key)        ;
                          in a,(c)                      ;
                          and zeuskeymask(Key)          ;
                          jr z KeyPressed               ;

                          ; Try the joystick...

                          in a,($1F)                    ;
                          xor $FF                       ;
                          and JoyBit                    ;

KeyPressed                ld hl,Label                   ;
                          call DWKey                    ;
                          mend

                        mDefineKey("A",KeyArrow)        ;
                        mDefineKeyPlusJoy("F",KeyFire,$20);
                        mDefineKey("D",KeyDrop)         ;
                        mDefineKey("C",KeyClose)        ;
                        mDefineKey("S",KeySword)        ;

                        ; These are common to both layouts

GSK_Common              mDefineKeyPlusJoy("L",KeyLight,$10);
                        mDefineKey("SPACE",Keysp)       ;
                        mDefineKey("1",Key1)            ;
                        mDefineKey("2",Key2)            ;
                        mDefineKey("P",KeyPortal)       ;

                        ; Fall into...

DWKey                   jr nz KillDWKey                 ; Skip if not pressed

                        ; It's pressed

                        ld a,(hl)                       ; Has it been reported?
                        or a                            ;
                        ret nz                          ; Yes, exit

                        ; No, set the pressed flag

                        inc a                           ; A = 1
                        ld (hl),a                       ; Set pressed now
                        inc hl                          ;
                        ld (hl),a                       ; Set has been pressed

                        ret                             ;

                ; Key not pressed, clear the pressed flag (but not the has pressed flag)

KillDWKey               xor a                           ;
                        ld (hl),a                       ;
                        ret                             ;

                        ; Alternate layout

GSK_Alternate           mDefineKey("J",KeyArrow)        ;
                        mDefineKeyPlusJoy("K",KeyFire,$20);
                        mDefineKey("N",KeyDrop)         ;
                        mDefineKey("M",KeyClose)        ;
                        mDefineKey("I",KeySword)        ;
                        mDefineKey("D",KeyDrop)         ;

                        jp GSK_Common                   ; Same

; See if a key has been pressed - return nz if so

ReadAKey                ld a,(hl)                       ; Has it been pressed?
                        or a                            ;
                        ret z                           ; Return if not as Z

                        ld a,0                          ; Clear the flag
                        ld (hl),a                       ;
                        ret                             ; Return NZ

; Draw the side wall around bigmaze

SideWall                ld ix,BigMaze+$70               ;
                        ld (ix),$96                     ;

                        ld b,$70                        ;
                        ld de,$80                       ;

SWallLP                 add ix,de                       ;
                        ld (ix),$9C                     ;

                        ld a,(ix-1)                     ;
                        and $F0                         ;
                        cp $90                          ;
                        jr nz SWallLPE                  ;

                        set 1,(ix)                      ;
SWallLPE                djnz SWallLP                    ;

                        ld (ix),$9A                     ;

                        ; Now, add the door to the inner wall

                        ld a,(cFloor)                   ;
                        and $7                          ;
                        ret z                           ; Not on the bottom

                        inc a                           ;
                        ld b,a                          ;

                        ld hl,TopLeftSanc+14207         ;
                        ld de,-896                      ;

SancDoor                add hl,de                       ;
                        djnz SancDoor                   ;

                        ld (hl),$94                     ;
                        ld b,4                          ;
                        ld de,-128                      ;

SancD1                  add hl,de                       ;
                        ld (hl),$90                     ;

                        djnz SancD1                     ;

                        add hl,de                       ;
                        ld (hl),$98                     ;
                        ret                             ;

; Show the build progressing

ShowProgress            ld a,[ShowProgX] 0              ; Move across
                        inc a                           ;
                        ld (ShowProgX),a                ;
                        and $1F                         ;
                        ld l,a                          ;

                        ld a,4                          ; Get a position
                        call RandRange                  ;

                        add a,19                        ; Avoid the titles
                        ld h,a                          ;

                        ; Add a thing

                        ld a,(cFloor)                   ;
                        add a,$D0                       ; Show a thing
                        call OutItStatus                ;

                        ret                             ;

; Generate all 8 floors of the maze

Gen8                    ld a,1                          ; Flag that we are building the tower
                        ld (bBuilding),a                ;

                        ld hl,RingTab+drt_Floor         ; Point at the floor
                        ld (hl),0                       ; None on the first floor

                        ld b,7                          ; We have seven rings to place

Gen8R                   loop lRingTable                 ; Skip this entry
                          inc hl                        ;
                          lend                          ;

                        ld a,7                          ; Get a floor number 0..6
                        call RandRange                  ;
                        inc a                           ; -> 1..7
                        ld (hl),a                       ; Put this ring [hl] on this floor.

                        djnz Gen8R                      ; Loop

                        ; We now have the 7 rings on seven random floors

                        ld hl,0                         ; 0
                        ld a,l                          ;
                        ld (nDTs),hl                    ;
                        ld (cFloor),a                   ;
                        ld (nRings),a                   ;

                        ; Loop for each floor

Gen8A                   call gpMazeList                 ; Point at the definition

                        ; Store the seed to generate it

                        ex de,hl                        ;
                        ld hl,Seed                      ;
                        ld bc,4                         ;
                        ldir                            ;
                        ex de,hl                        ;

                        call BuildTheMaze               ;
                        call ShowProgress               ;

                        call DrawBigmaze                ;
                        call ShowProgress               ;

                        call InitMonsters               ;

                        call InitTreasure               ;

                        call InitMagic                  ;

                        call SaveFloor                  ;
                        call ShowProgress               ;

                        ; Now, find somewhere for all the rings that are on this floor...

                        ld a,(cFloor)                   ; The current floor
                        and $7                          ;

                        ld iy,RingTab                   ; Search the ring table
                        ld b,8                          ;

Gen8RA                  cp (iy+drt_Floor)               ; On this floor?
                        call z DefRing                  ; Yes, find somewhere for it

                        loop lRingTable                 ; Skip to next
                          inc iy                        ;
                          lend                          ;

                        djnz Gen8RA                     ; Loop

                        ; Loop to next floor

                        inc a                           ;
                        ld (cFloor),a                   ;
                        cp 8                            ;
                        jr nz Gen8A                     ;

                        ; Finished building

                        xor a                           ; Flag that we are not building the tower
                        ld (bBuilding),a                ;

                        ret                             ;

                ; This ring is on this floor. Find somewhere for it

DefRing                 push af                         ;
                        push bc                         ;

DefRing1                call FindPosition               ; Find an empty square in the maze

                        push hl                         ; Save
                        call ConvBM_To_XY_HL            ; See what the X is...
                        ld a,l                          ; Is it far enough to the LHS?
                        pop hl                          ; Restore

                        cp 30                           ;
                        jr nc DefRing1                  ; Too far to the right - try another position

                        ; Mark that there is a ring here...

                        ld (iy+drt_pMaze_L),l           ; Save the putative position
                        ld (iy+drt_pMaze_H),h           ;
                        ld (hl),$8F                     ;

                        pop bc                          ;
                        pop af                          ;
                        ret                             ;

; Point at the maze list for this floor

gpMazeList              ld a,(cFloor)                   ; 512 bytes per floor
                        and $7                          ;
                        add a,a                         ;
                        ld d,a                          ;
                        ld e,0                          ;

                        ld hl,MazeList                  ;
                        add hl,de                       ;

                        ret                             ;

; Save the state of a floor
; There is an undetected failure case here - if there's too much treasure on a level it explodes
; ie you can kill the game by taking treasure from one floor to another (not the hall, that's safe)

SaveFloor               call gpMazeList                 ;

                        inc hl                          ; Skip the random seed
                        inc hl                          ;
                        inc hl                          ;
                        inc hl                          ;

                        ; Now, add the monsters

                        ld ix,MonsterList               ;
                        ld de,lMonst                    ;
                        ld b,nMonst                     ;

SFloor1                 ld a,(ix+dm_pMaze_L)            ; PtrL
                        ld (hl),a                       ;
                        inc hl                          ;
                        ld a,(ix+dm_pMaze_H)            ; PtrH
                        ld (hl),a                       ;
                        inc hl                          ;
                        ld a,(ix+dm_Char)               ; Char
                        ld (hl),a                       ;
                        inc hl                          ;
                        ld a,(ix+dm_Flags)              ; Bit 7 of Flags + MoveType
                        and $80                         ;
                        or (ix+dm_MoveType)             ;
                        ld (hl),a                       ;
                        inc hl                          ;

                        add ix,de                       ;

                        djnz SFloor1                    ;

                        ; Now, add anything from B0 .. CF (Treasure and Magic)

                        ld de,BigMaze                   ;
                        ld c,$70                        ;
SFloor2                 ld b,$70                        ;

SFloor3                 ld a,(de)                       ;
                        and $F0                         ;
                        cp $B0                          ;
                        jr c SFloor3A                   ;

                        cp $D0                          ;
                        jr nc SFloor3A                  ;

                        ld a,(de)                       ;
                        ld (hl),e                       ;
                        inc hl                          ;
                        ld (hl),d                       ;
                        inc hl                          ;
                        ld (hl),a                       ;
                        inc hl                          ;

SFloor3A                inc de                          ; Loop across X
                        djnz SFloor3                    ;

                        ; Skip the outside of the tower

                        push hl                         ;
                        ld hl,$10                       ;
                        add hl,de                       ;
                        ex de,hl                        ;
                        pop hl                          ;

                        dec c                           ; Loop down Y
                        jr nz SFloor2                   ;

                        ; Add a terminator

                        ld (hl),0                       ;
                        inc hl                          ;
                        ld (hl),0                       ;
                        inc hl                          ;
                        ld (hl),0                       ;
                        ret                             ;

; Recreate a floor

Recreate                call gpMazeList                 ;

                        ld de,Seed                      ;
                        ld bc,4                         ;
                        ldir                            ;

                        push hl                         ;

                        call BuildTheMaze               ;

                        call DrawBigmaze                ;

                        call InitMonsters               ;

                        pop iy                          ;

                        ld ix,MonsterList               ;
                        ld de,lMonst                    ;
                        ld b,nMonst                     ;

Rec1                    ld l,(iy+dml_pMaze_L)           ;
                        ld h,(iy+dml_pMaze_H)           ;
                        ld a,(hl)                       ;
                        cp ' '                          ;
                        ld (ix+dm_pMaze_L),l            ;
                        ld (ix+dm_pMaze_H),h            ;

                        call nz OpenIfNess              ;

                        ld a,(iy+dml_Char)              ;
                        ld (ix+dm_Char),a               ;

                        ld a,(iy+dml_MoveType)          ; 7 bits of move type
                        and $7F                         ;
                        ld (ix+dm_MoveType),a           ;
                        ld a,(iy+dml_MoveType)          ;

                        inc iy                          ;
                        inc iy                          ;
                        inc iy                          ;
                        inc iy                          ;

                        and $80                         ; Set the dead flag
                        or (ix+dm_Flags)                ;
                        ld (ix+dm_Flags),a              ;

                        add ix,de                       ;

                        djnz Rec1                       ;

Rec2                    ld l,(iy)                       ;
                        inc iy                          ;
                        ld h,(iy)                       ;
                        inc iy                          ;
                        ld a,(iy)                       ;
                        inc iy                          ;

                        or a                            ;
                        jr z Rec3                       ;

                        ld a,(hl)                       ;
                        cp ' '                          ;
                        call nz OpenIfNess              ;

                        ld a,(iy-1)                     ;
                        ld (hl),a                       ;

                        jr Rec2                         ;

Rec3                    call InitProjList               ; Clear the projectiles

                        ; Place any rings that are on this floor

                        ld ix,RingTab                   ; Point at them
                        ld b,8                          ; There are 8
                        ld c,$88                        ; First character
                        ld a,(cFloor)                   ; The current floor

Rec4                    cp (ix+drt_Floor)               ; Is this ring on this floor?
                        jr nz Rec5                      ; No, skip

                        ld l,(ix+drt_pMaze_L)           ; Get the address
                        ld h,(ix+drt_pMaze_H)           ; Get the address
                        ld (hl),c                       ; Plant this ring

Rec5                    inc c                           ; Change to next ring

                        loop lRingTable                 ; Skip forwards
                          inc ix                        ;
                          lend                          ;

                        djnz Rec4                       ; Next ring

                        ; Flag that we are not a virgin???

                        xor a                           ;
                        ld (Virgin),a                   ;

                        ret                             ;

; Are we looking at a door character?

OpenIfNess              cp $DC                          ; Horizontal door?
                        jr z OINHor                     ;

                        cp $DD                          ;
                        ret nz                          ; No, exit

                        ; Open a vertical door

                        push hl                         ;
                        push af                         ;
                        push de                         ;
                        push bc                         ;

                        ld de,128                       ;
                        call MMDoorO2                   ;
                        jr OINEx                        ;

                        ; Open a horizontal door

OINHor                  push hl                         ;
                        push af                         ;
                        push de                         ;
                        push bc                         ;

                        ld de,1                         ;
                        call MMDoorO2                   ;

OINEx                   pop bc                          ;
                        pop de                          ;
                        pop af                          ;
                        pop hl                          ;
                        ret                             ;

; Draw the tower

InitSanctuary           ld hl,BigMaze                   ;
                        ld de,BigMaze+1                 ;
                        ld bc,BigMazeSize-1             ;
                        ld (hl),' '                     ;
                        ldir                            ;

                        ld hl,TopLeftSanc               ;
                        ld (hl),$95                     ;
                        ld b,13                         ;
InitSanc1               inc hl                          ;
                        ld (hl),$93                     ;
                        djnz InitSanc1                  ;

                        inc hl                          ;
                        ld (hl),$96                     ;
                        ld de,128                       ;
                        ld b,111                        ;
InitSanc2               add hl,de                       ;
                        ld (hl),$9C                     ;
                        djnz InitSanc2                  ;

                        add hl,de                       ;
                        ld (hl),$9A                     ;
                        ld b,13                         ;
InitSanc3               dec hl                          ;
                        ld (hl),$93                     ;
                        djnz InitSanc3                  ;

                        dec hl                          ;
                        ld (hl),$99                     ;
                        ld de,-128                      ;
                        ld b,13-7                       ;
InitSanc4               add hl,de                       ;
                        ld (hl),$9C                     ;
                        djnz InitSanc4                  ;

                        ; Draw the door openings (outer) going up...

                        ld b,7+1                        ;

InitSanc5               add hl,de                       ;
                        ld (hl),$9C                     ;
                        add hl,de                       ;
                        ld (hl),$94                     ;
                        add hl,de                       ;
                        add hl,de                       ;
                        add hl,de                       ;
                        add hl,de                       ;
                        add hl,de                       ;
                        ld (hl),$98                     ;
                        djnz InitSanc5                  ;

                        ; Draw the stairs back down

                        push hl                         ;
                        ld b,49                         ;
InitSanc6               add hl,de                       ;
                        ld (hl),$9C                     ;
                        djnz InitSanc6                  ;
                        pop hl                          ;

                        ld (hl),$99                     ;
                        push hl                         ;

                        ld de,-3584                     ;
                        add hl,de                       ;

                        ld (hl),$9D                     ;
                        ld b,13                         ;
InitSanc7               inc hl                          ;
                        ld (hl),$93                     ;
                        djnz InitSanc7                  ;

                        inc hl                          ;
                        ld (hl),$9E                     ;

                        pop hl                          ;  Top-left of top flightl                         ;
                        push hl                         ;

                        ; Top line of stairs

                        ld b,6                          ;
InitSanc7a              inc hl                          ;
                        ld (hl),$93                     ;
                        djnz InitSanc7a                 ;

                        ; RHS of stairs

                        ld (hl),$96                     ; -\
                        ld de,128                       ;  !

                        ld b,55                         ;

InitSanc8               add hl,de                       ;
                        ld (hl),$9C                     ;
                        djnz InitSanc8                  ;

                        add hl,de                       ;
                        ld (hl),$98                     ;

                        pop hl                          ;  Restore TOP-LEFT of top flight

                        ld de,129-1                     ;
                        add hl,de                       ;

                        ; Draw the stairs

                        ld c,$87                        ; Floor-flag
InitSancD               ld a,$FC                        ;
                        call Rung6                      ;

                        ld b,3                          ;
                        ld a,c                          ;

InitSanc9               call Rung6                      ;
                        djnz InitSanc9                  ;

                        inc hl                          ; Treads

                        ld b,3                          ;
                        ld a,$FD                        ;

InitSancB               call Rung                       ;
                        djnz InitSancB                  ;

                        dec hl                          ;

                        dec c                           ;
                        ld a,c                          ;
                        cp $7F                          ;
                        jr nz InitSancD                 ;

                        inc hl                          ;

                        ld b,5                          ;
                        ld a,$FC                        ;
InitSancE               call Rung                       ;
                        djnz InitSancE                  ;

                        ; Text in sanctury

                        ld b,16                         ;
                        ld de,SMess                     ;
                        ld hl,TopLeftSanc+258           ;

SMessL                  ld c,11                         ;
                        push hl                         ;

SMessl                  ld a,(de)                       ;
                        ld (hl),a                       ;
                        inc de                          ;
                        inc hl                          ;
                        dec c                           ;
                        jr nz SMessl                    ;

                        pop hl                          ;
                        push bc                         ;

                        ld bc,128                       ;
                        add hl,bc                       ;

                        pop bc                          ;
                        djnz SMessL                     ;

                        ret                             ;

Rung6                   push bc                         ;

                        ld b,6                          ;
Rung6Lp                 ld (hl),a                       ;
                        inc hl                          ;
                        djnz Rung6Lp                    ;

                        ld bc,$80-6                     ;
                        add hl,bc                       ;

                        pop bc                          ;
                        ret                             ;

Rung                    push bc                         ;

                        ld b,5                          ;
Rung1                   ld (hl),a                       ;
                        inc hl                          ;
                        djnz Rung1                      ;

                        ld bc,$80-5                     ;
                        add hl,bc                       ;

                        pop bc                          ;
                        ret                             ;

; See if the floor has changed

NFloor                  ld a,[NFloorFl]0                ; New floor -> b
                        dec a                           ;
                        ld b,a                          ;

                        ld a,(cFloor)                   ; Ignore if cfloor=8
                        cp 8                            ;
                        ret z                           ;

                        and $7                          ; Has the floor changed?
                        cp b                            ;
                        ret z                           ; No.

                        ; Different floor.

                        push bc                         ; Save the current floor
                        or a                            ; Floor 0?
                        call nz SaveFloor               ; Save it if it isn't
                        pop bc                          ;

                        ld a,b                          ; Change to the new floor
                        ld (cFloor),a                   ;

                        or a                            ; Are we on floor zero?
                        jr nz NFloorRecreate            ; No

                        ld a,(nRings)                   ; Got all the rings?
                        cp 7                            ;
                        jr z NFloorRecreate             ; Yes, so recreate it

                        ; We're on floor 0 without all the rings

ClearFloorZero          call ClearMonsters              ; Clear them
                        call InitProjList               ; Clear them
                        call DrawBigmaze                ; Clear it

                        ld hl,sTerrorIncognita          ; Add a message
                        ld de,BigMaze+101*128+80        ;
                        ld bc,lTerrorIncognita          ;
                        ldir                            ;

                        jp PlaceMan                     ; Place the man in the maze

sTerrorIncognita        db "Terror Incognita..?"        ;
lTerrorIncognita        equ *-sTerrorIncognita          ;

NFloorRecreate          call Recreate                   ; Recreate the new floor

                        call PlaceMon                   ; Place the monsters

                        call OpenBasement               ; If required

                        jp PlaceMan                     ; Place the man in the maze

; See if a monster wants to open a door. HL is pointing at the door.

MonODoor                push hl                         ;
                        push de                         ;
                        push bc                         ;

                        call FindProjSpace              ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;

                        ret z                           ; We don't have any projectile space

                        push hl                         ;
                        push de                         ;
                        push bc                         ;

                        ld c,50                         ;

                        push hl                         ;

                        ld e,(ix+dm_pMaze_L)            ; From the monster
                        ld d,(ix+dm_pMaze_H)            ;
                        ld hl,(pMan)                    ; To the man

                        call RangeDoor                  ;
                        pop hl                          ;

                        ld (iy+dp_Life),0               ;
                        jr c,MonODRnd                   ; Can't see the man, open randomly

                        ; Can see the man, but is it through a door?

                        ld a,[DoorFlag] 0               ;
                        or a                            ;
                        jr z,MonODRnd                   ; Can see him but not through a door, open randomly anyway.

                        ; We can see him through the door, so open it

                        ld a,(hl)                       ;
                        call OpenIfNess                 ;

                        call MoveT2Mark                 ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;

                        ret                             ;

        ; Randomly open a door

MonODRnd                ld a,r                          ;
                        and 3                           ;
                        jr nz MonODoorEx                ;

                        ld a,(hl)                       ;
                        call OpenIfNess                 ;

                        call MoveT2Mark                 ;

MonODoorEx              pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ;

; See if we've escaped the dungeon

OpenPlan                ld a,(cFloor)                   ;
                        and $7                          ;
                        jr nz OpenPlanFEx               ;

                        ld a,[Virgin] 0                 ;
                        or a                            ;
                        ret z                           ;

                        ld a,(cFloor)                   ;
                        cp 8                            ;
                        ret nz                          ;

                        jp DunIt                        ;

OpenPlanFEx             xor a                           ;
                        ret                             ;

; Count up the treasure in the maze - result in DE

CTres                   ld hl,BigMaze                   ;
                        ld bc,BigMazeSize-1             ;
                        ld de,0                         ;

CTresL                  ld a,(hl)                       ;
                        and $F0                         ;
                        cp $B0                          ;
                        jr nz,CTresN                    ;

                        ld a,(hl)                       ;
                        and $F                          ;
                        add a,e                         ;
                        ld e,a                          ;
                        ld a,0                          ;
                        adc a,d                         ;
                        ld d,a                          ;

CTresN                  cpi                             ;
                        jp v CTresL                     ;

                        ret                             ;

; They've won, dammit - calculate the score. No round numbers in sight...

; Max score =           (40*8)*15       Treasure  4800
;                       8 * 1024        Rings     8192  ()
;                       (32*8)*2        Things    512   ()
;                       1024            Bonus     128   ()

CalcScore_WithTreasure  call CTres                      ; DE := treasure

CalcScore_NoTreasure    ld hl,(nDTs)                    ; Dead things * 2
                        add hl,hl                       ;

                        add hl,de                       ; + Treasure

                        ld a,(nRings)                   ; Rings * 1024
                        ld d,a                          ;
                        ld e,0                          ;

                        add hl,de                       ; + Rings
                        add hl,de                       ; + Rings
                        add hl,de                       ; + Rings
                        add hl,de                       ; + Rings

                        cp 8                            ; But return if we haven't collected them all
                        ret nz                          ;

                        ld de,1024                      ; + Finishing bonus
                        add hl,de                       ;
                        ret                             ;

; See if we can heal this wound, return C if we've not enough magic...

TryToHeal               ld a,(CurrentMagic)             ; Enough magic?
                        sub 30                          ;
                        ret c                           ; No, return

                        ld (CurrentMagic),a             ; See how much healing we can perform
                        ld a,r                          ;
                        and $F                          ;
                        add a,16                        ;
                        ld b,a                          ; b:=healing amount

                        ld a,(Wounds)                   ; Reduce the wounds
                        sub b                           ;
                        jr nc TryHeal1                  ; We're OK

                        ; We took away more than there was, so make the result zero

                        xor a                           ; Clear them all
TryHeal1                ld (Wounds),a                   ;

                        or a                            ; Ret NC
                        ret                             ;

; Shown the score page

ShowTitlesRev           ld hl,$704                      ;
                        ld de,sMessN1                   ;
                        call SPrint                     ;

                        ld hl,$604                      ;
                        jr ST_1                         ;

ShowTitles              ld hl,$604                      ;
                        ld de,sMessN1                   ;
                        call SPrint                     ;

                        ld hl,$704                      ;
ST_1                    ld de,sMessN2                   ;
                        call SPrint                     ;

                        ld hl,1                         ;
                        ld de,sMess6                    ;
                        call SPrint                     ;

                        ld hl,$100                      ;
                        ld de,sMess7                    ;
                        call SPrint                     ;

                        ld hl,$400                      ;
                        ld de,sMess8                    ;
                        call SPrint                     ;

                        ld hl,$801                      ;
                        ld de,sMessN3                   ;
                        jp SPrint                       ;

; Show the scores

DrawScoreFixed          call ShowTitles                 ; Show them

                        ld hl,ScorePos+$F               ;
                        ld de,sMess1                    ;
                        call SPrint                     ;

                        ld hl,ScorePos+$100             ;
                        ld de,sMess3                    ;
                        call SPrint                     ;

                        ld hl,ScorePos+$200             ;
                        ld de,sMess4                    ;
                        call SPrint                     ;

                        ld hl,ScorePos+$300             ;
                        ld de,sMess9                    ;
                        call SPrint                     ;

                        ld hl,ScorePos+$400             ;
                        ld de,sMess5                    ;
                        call SPrint                     ;

                        ld de,sMessA                    ;
                        ld hl,$F00                      ;
                        call SPrint                     ;

                        ; Show the rings

                        ld ix,RingTab+lRingTable*8      ; Point at one past the end of the table
                        ld hl,$F0E                      ;
                        ld bc,$088F                     ;

PRLp                    ld a,(ix+drt_Floor-lRingTable)  ; Floor on the previous entry
                        cp $FF                          ;
                        jr nz PRLp1                     ;

                        ld a,c                          ;
                        call OutItStatus                ;

                        inc l                           ; Move right

PRLp1                   dec c                           ; Next ring character

                        loop lRingTable                 ; Skip backwards
                          dec ix                        ;
                          lend                          ;

                        djnz PRLp                       ;

                        ; Draw the bits that can change

DrawScoreEtc            call PrintMagic                 ;

                        call PrintWound                 ;

                        call PrintDTs                   ;

                        ld ix,(nDTs)                    ;
                        ld hl,ScorePos+$30A             ;
                        call PDec_IX                    ;

                        call PrintArrows                ;

                        ; Add arrow direction

                        ld hl,ScorePos+$500             ;
                        ld de,sMess5a                   ;
                        call SPrint                     ;

                        ld a,(ArrDir)                   ; Which way?
                        ld de,sUp                       ;
                        or a                            ;
                        jr z DSE_ArrDirn                ;

                        ld de,sRight                    ;
                        dec a                           ;
                        jr z DSE_ArrDirn                ;

                        ld de,sDown                     ;
                        dec a                           ;
                        jr z DSE_ArrDirn                ;

                        ld de,sLeft                     ;

DSE_ArrDirn             ld hl,ScorePos+$50C             ;

                        ; Fall into

SPrint                  ld c,e                          ;

SPrintLp                ld a,(de)                       ;
                        xor c                           ;
                        ret z                           ;

                        call OutItStatus                ;

                        ld a,c                          ;
                        add a,encoff                    ;
                        ld c,a                          ;

                        inc de                          ;
                        inc hl                          ;

                        jr SPrintLp                     ;

sMess1                  dbx *,"0%          100%",0      ;
sMess3                  dbx *,"Magic",0                 ;
sMess4                  dbx *,"Wounds",0                ;
sMess5                  dbx *,"Arrows",0                ;
sMess5a                 dbx *,"Arrows fire",0           ;
sUp                     dbx *,"up   ",0                 ;
sRight                  dbx *,"right",0                 ;
sDown                   dbx *,"down ",0                 ;
sLeft                   dbx *,"left ",0                 ;

sMess6                  dbx *,"-- Halls of the Things --",0;
sMess7                  dbx *,"___________________________",0;
sMess8                  dbx *,"(c) Design-Design Software",0;
sMess9                  dbx *,"Ex-Things",0             ;
sMessA                  dbx *,"Rings found",0           ;

sMessN1                 dbx *,"Simon Brattel",0         ;
sMessN2                 dbx *,"Neil Mottershead",0      ;
sMessN3                 dbx *,"&  Martin Horsley",0     ;

PrintMagic              ld hl,ScorePos+$10E             ;
                        ld a,(CurrentMagic)             ;

                        cp 255                          ; If it's full show a full bar
                        jr z PBarF                      ;

                        jr PrintBar                     ;

PrintWound              ld hl,ScorePos+$20E             ;
                        ld a,(Wounds)                   ;
                        jr PrintBar_128                 ;

PrintArrows             ld hl,ScorePos+$40E             ;
                        ld a,(ArrowCount)               ;
                        cp 255                          ; If it's full show a full bar
                        jr z PBarF                      ;
                        jr PrintBar                     ;

PrintDTs                ld hl,ScorePos+$30E             ;

                        ld de,(nDTs)                    ; nDead things (0 .. 256)

                        ld a,e                          ; Get the number if it's less than 256

                        dec d                           ; Was it 256?
                        jr z PBarF                      ; Yes, skip

                        ; Print a bar-graph, 0 .. 255 where 255 is one less than max.

PrintBar                srl a                           ; / 2  (0..7F)
                        jr PrintBar_128                 ;

                        ; Show a full bar

PBarF                   ld a,128                        ; Full bar

PrintBar_128            call PBarRHS                    ;

                        push hl                         ;
                        ld de,17                        ; Point at the far end
                        add hl,de                       ;
                        call PBarLHS                    ;
                        pop hl                          ;
                        inc l                           ;

                        ; Now, fill it in

                        ld b,16                         ; This many

PB_Lp                   cp 8                            ; Less than a full one?
                        call nc PB_Full                 ;
                        call c PB_Partial               ;

                        djnz PB_Lp                      ;

                        ret                             ; Done

PB_Full                 sub 8                           ;
                        push af                         ;

                        ld a,$F0                        ;
                        call OutItStatus                ;

                        inc l                           ;

                        pop af                          ;
                        ret                             ;

PB_Partial              and $7                          ;
                        or $E8                          ;
                        call OutItStatus                ;
                        inc l                           ;

                        ld a,0                          ; Done
                        ret                             ;

PBarRHS                 push af                         ; LHS
                        ld a,$F1                        ;
                        call OutItStatus                ;
                        pop af                          ;
                        ret                             ;

PBarLHS                 push af                         ; RHS
                        ld a,$F2                        ;
                        call OutItStatus                ;
                        pop af                          ;
                        ret                             ;

; Show a number

PDec_IX                 ld c,1                          ;
                        ld de,-100                      ;
                        call PDecNL1                    ;
                        ld de,-10                       ;
                        call PDecNL1                    ;
                        ld a,ixl                        ;
                        add a,"0"                       ;
                        jp OutItStatustInc              ;

PDecNL1                 xor a                           ;
PDecNL2                 inc a                           ;
                        add ix,de                       ;
                        jr c PDecNL2                    ;
                        push hl                         ;
                        push ix                         ;
                        pop hl                          ;
                        sbc hl,de                       ;
                        push hl                         ;
                        pop ix                          ;
                        pop hl                          ;
                        dec a                           ;
                        or "0"                          ;

                        cp c                            ;
                        jp z OutItStatustInc            ;

                        cp "0"                          ;
                        ret z                           ;

                        ld c,"0"                        ;
OutItStatustInc         call OutItStatus                ;
                        inc l                           ;
                        ret                             ;

; Redraw the tile-display
Tile_TopLeft            equ $4000                       ; Screen tile-top-left

; Given A=char and H=ScreenY, L=ScreenX show this tile

OutItNew                push hl                         ; Save
                        push de                         ;

                        ld e,h                          ; Y
                        ld d,80                         ;
                        mul d,e                         ; Scaled Y
                        ld h,0                          ;
                        add hl,de                       ; Y*80+X
                        add hl,Tile_TopLeft             ; + Base

                        ld (hl),a                       ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ; Done

OutItNew_Blank          push hl                         ; Save
                        push de                         ;

                        ld e,h                          ; Y
                        ld d,80                         ;
                        mul d,e                         ; Scaled Y
                        ld h,0                          ;
                        add hl,de                       ; Y*80+X
                        add hl,Tile_TopLeft             ; + Base

                        ld (hl),' '                     ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ; Done

OutItStatus             push hl                         ; Save
                        push de                         ;

                        ld e,h                          ; Y
                        ld d,80                         ;
                        mul d,e                         ; Scaled Y
                        ld h,0                          ;
                        add hl,de                       ; Y*80+X
                        add hl,Tile_TopLeft+25+5*80     ; + Base

                        ld (hl),a                       ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ; Done

; Save the player chars and modify them

RD_SavePlayer           ld a,(GameBType)                ; Are we dead
                        or a                            ;
                        jp m RD_SP_Dead                 ; Yes, different bytes

                        ; Save the two chars under the player, then update them

                        ld hl,(pMan)                    ; Get the square the man is on and the one below it
                        ld a,(hl)                       ;
                        ld (RD_PlayerChar1),a           ;
                        ld (RD_pPlayerChar1),hl         ;

                        ld a,(ManAngle)                 ;
                        call CDirect                    ;

                        add a,a                         ; Calc the right char for this angle
                        add a,$A8                       ;
                        ld (hl),a                       ; Set it
                        inc a                           ; Legs
                        ld b,a                          ; Save

                        ; Legs

                        add hl,128

                        ld a,(hl)                       ;
                        ld (RD_PlayerChar2),a           ;
                        ld (RD_pPlayerChar2),hl         ;

                        ld (hl),b                       ; Save

                        ; Show the sword?

                        ld hl,[SwdPos] 0                ; Get the position
                        ld a,l                          ;
                        or h                            ;
                        jr z RD_SP_ClearSword           ; No sword, exit

                        ld a,(hl)                       ; Save char under it
                        ld (RD_PlayerChar3),a           ;
                        ld (RD_pPlayerChar3),hl         ;

                        ld (hl),[SwdChar] 0             ;
                        ret                             ; Done

RD_SP_ClearSword        ld hl,DummyByte                 ;
                        ld (RD_pPlayerChar3),hl         ;
                        ret                             ;

                ; Use the dead man characters and positions

RD_SP_Dead              ld hl,(pMan)                    ; Position

                        ld a,(hl)                       ;
                        ld (RD_PlayerChar1),a           ;
                        ld (RD_pPlayerChar1),hl         ;

                        ld (hl),$F3                     ; Dead man chars

                        ; Legs

                        inc l                           ; Move right

                        ld a,(hl)                       ;
                        ld (RD_PlayerChar2),a           ;
                        ld (RD_pPlayerChar2),hl         ;

                        ld (hl),$F4                     ; Legs
                        ret                             ; Done

; Given a pointer to the top-left, draw the display

RedrawDisplay           ld a,[WhichScreen] 0            ; Show the maze or the status?
                        cp stStatus                     ; Status?
                        ret z                           ; Yep - just the normal tile memory

                        ; Now, we have a terrible hack with the player

                        call RD_SavePlayer              ;

                        ; Show the maze

                        ld hl,[DispCurrX16] 0           ; Get X in fixed point coordinates
                        ld bc,-39*$80                   ; Subtract the screen centre
                        add hl,bc                       ;
                        add hl,hl                       ; H:=Integer
                        ld e,h                          ; Save X

                        ld hl,[DispCurrY16] 0           ; Get X in fixed point coordinates
                        ld bc,-16*$80                   ; Subtract the screen centre
                        add hl,bc                       ;
                        add hl,hl                       ; H:=Integer
                        ld l,e                          ; HL := Y,X

                        ld (pFrameX),hl                 ; Save the top-left X

                        ; Now, we also need to setup IX as a pointer to this (possible outside) maze character

                        push hl                         ; Save it

                        ; X in L is already correct...
                        ; Y in H is needs to be divided by two and offset to C000

                        ld c,l                          ; Save X
                        ld a,l                          ;

                        sra h                           ; Y*$80
                        ld l,0                          ;
                        rr l                            ;

                        and a,%0 1111111                ;
                        or l                            ;
                        ld l,a                          ;

                        bit 7,c                         ; X-ve

                        ld a,h                          ;
                        add a,high BigMaze              ;
                        ld h,a                          ;

                        push hl                         ;
                        pop ix                          ;

                        pop hl                          ; Restore

                        ld de,Tile_TopLeft              ; Point at the tile data

                        ; Now, we need to drive the X/Y scroll registers

                        ld a,(DispCurrX16)              ; 7-bits of fraction
                        rra                             ;
                        rra                             ;
                        rra                             ;
                        rra                             ;
                        and %00000 111                  ; 0..7
                        nextreg NR_TILEMAP_OFFSET_X,a   ;
//                      nextreg NR_TILEMAP_OFFSET_X_MSB,0;

                        ld a,(DispCurrY16)              ; 7-bits of fraction
                        rra                             ;
                        rra                             ;
                        rra                             ;
                        rra                             ;
                        and %00000 111                  ; 0..7
                        nextreg NR_TILEMAP_OFFSET_Y,a   ;

                        ; Setup the line copying code

                        bit 7,l                         ; Outside the maze?
                        jp nz RDS_ToTheLHS              ; We're starting to the left of the maze

                        ; Inside the maze

                        ld a,128                        ; This wide
                        sub a,l                         ;

                        cp a,80                         ; If this is more than 80 we only copy 80
                        jp nc RDS_Copy80Chars           ; We're going to copy 80 chars

                        ; now copy A chars then border of 80-A

                        push hl                         ; Save the x/y

                        ld hl,RDL_HandlerMoatLast       ; Do the maze first
                        ld (RDL_Vector),hl              ;

                        ; Copy A maze chars

                        ld b,a                          ; Save

                        neg                             ; -A
                        add a,80                        ; 80-A
                        add a,a                         ; *2

                        ld hl,CopyHLDE_80               ; Point at the start of this run of instructions
                        add hl,a                        ;
                        ld (RDL_MLMazeVector),hl        ;

                        ld a,b                          ; Restore

                        ; Now fill 80-A moat chars

                        ld hl,WriteDE_A_80              ; A block of 80 instructions
                        add a,a                         ; 2 bytes per
                        add hl,a                        ;
                        ld (RDL_MLMoatVector),hl        ;

                        pop hl                          ; Restore X/y

                        ld a,1                          ;
                        out ($FE),a                     ;

RD_DoLines              for j:=0 to 31                  ;
                          call RD_Line                  ;
                          next                          ;

RD_RestorePlayer        ld a,[RD_PlayerChar1] 0         ;
                        ld ([RD_pPlayerChar1] DummyByte),a ;

                        ld a,[RD_PlayerChar2] 0         ;
                        ld ([RD_pPlayerChar2] DummyByte),a ;

                        ld a,[RD_PlayerChar3] 0         ;
                        ld ([RD_pPlayerChar3] DummyByte),a ;

                        ret                             ; Done

                        ; Setup to start to the left

RDS_ToTheLHS            ld a,l                          ; How many moat characters to start with

                        neg                             ; Number to fill
                        cp 80                           ; Entire line
                        jr nc RDS_FillLineWithMoat      ; Fill an entire line

                        push hl                         ; Save the y/x

                        ; A is the number of moat chars to write, 0..79

                        push af                         ; Save

                        ld hl,RDL_HandlerMoatFirst      ; Do some moat first
                        ld (RDL_Vector),hl              ;

                        neg                             ; -A
                        add a,80                        ; 80-A
                        add a,a                         ; *2

                        ld hl,WriteDE_A_80              ; Point at the start of this run of instructions
                        add hl,a                        ;
                        ld (RDL_MFMoatVector),hl        ;

                        pop af                          ;

                        ; Now copy the rest of the maze, 80-A chars

                        ld hl,CopyHLDE_80               ; A block of 80 ldi's
                        add a,a                         ; 2 bytes per LDI
                        add hl,a                        ;
                        ld (RDL_MFMazeVector),hl        ;

                        pop hl                          ; Restore y/x
                        jp RD_DoLines                   ; And do them all

                        ; We're filling with the moat

RDS_FillLineWithMoat    ld bc,RDL_HandlerFillWithMoat   ; Use this code
                        ld (RDL_Vector),bc              ;

                        jp RD_DoLines                   ; Do it

                        ; We're copying a whole line

RDS_Copy80Chars         ld bc,RDL_HandlerAllMaze        ; Copy 80 chars
                        ld (RDL_Vector),bc              ;

                        jp RD_DoLines                   ; And do them all

                        ; Handle one line

RD_Line                 ld a,h                          ; Are we above the top or below the bottom?
                        cp a,$71                        ;
                        jr nc RDL_HandlerFillWithMoat   ; Yes, fill it with the moat char

                        ; Now do the line code

                        jp [RDL_Vector] Ret             ;

                        ;

RDL_HandlerFillWithMoat ld a,$FF                        ; Moat
                        call WriteDE_A_80               ;

                        ld bc,128                       ; Move maze pointer
                        add ix,bc                       ;

                        inc h                           ; Inc Y

Ret                     ret                             ; Done

RDL_HandlerMoatFirst    push hl                         ; Save x/y

                        ld a,$FF                        ; Moat
                        call [RDL_MFMoatVector] Ret     ; Draw the moat

                        push ix                         ; Get the maze pointer
                        pop hl                          ;

                        ld a,l                          ; Point at the LHS of the maze
                        and %10000000                   ;
                        ld l,a                          ;

                        call [RDL_MFMazeVector] Ret     ; Copy the maze

                        ld bc,128                       ; Move down
                        add ix,bc                       ;

                        pop hl                          ; Restore
                        inc h                           ;

                        ret                             ; Done

RDL_HandlerAllMaze      push hl                         ; Save x/y

                        push ix                         ; Get the maze pointer
                        pop hl                          ;

                        call CopyHLDE_80                ; Copy a line

                        ld bc,128                       ; Move down
                        add ix,bc                       ;

                        pop hl                          ; Restore
                        inc h                           ;

                        ret                             ; Done

RDL_HandlerMoatLast     push hl                         ; Save

                        push ix                         ; Get the maze pointer
                        pop hl                          ;

                        call [RDL_MLMazeVector] Ret     ; Copy the maze
                        ld a,$FF                        ; Moat
                        call [RDL_MLMoatVector] Ret     ; Draw the moat

                        ld bc,128                       ; Move down
                        add ix,bc                       ;

                        pop hl                          ; Restore
                        inc h                           ;

                        ret                             ; Done

; Calc where the display ought to be

CalcDisplayTargetPos    ld hl,(pMan)                    ; Get the screen posn

                        ld a,l                          ; Get X/Y
                        and $7F                         ;
                        add hl,hl                       ; H:=Y+Offset BigMaze starts at C000 so offset = 80
                        ld e,a                          ;

                        ld a,h                          ;
                        and $7F                         ; Lose the offset
                        ld d,a                          ;

                        ; D = MazeY, E = MazeX

                        ; Now, allow for the direction the man is pointing...

                        ld a,(ManAngle)                 ; Which way are we facing?

                        ld h,[AngleOffsetX] 0           ; Assume right-facing justify

                        cp 1                            ; Right?
                        jr z JustGotXDisp               ; Yep, skip

                        ld h,[AngleOffsetXNeg] 0        ; Assume right-facing justify

                        cp 3                            ; Left?
                        jr z JustGotXDisp               ;

                        ld a,[JustXDisp]0               ; Get the last offset
                        ld h,a                          ;

JustGotXDisp            ld a,h                          ; Get it
                        ld (JustXDisp),a                ; Save it

                        ; Offset the target position

                        add a,e                         ; a:=target X

                        ; Positive, but clip to a reasonable range

                        cp 36                           ;
                        jr c JGXD_Neg                   ;

                        cp $C0                          ;
                        jr nc JGXD_Neg                  ;

                        cp 91                           ;
                        jr c JGXSD_Okay                 ;

                        ld a,91                         ;
                        jr JGXSD_Okay                   ;

                        ; Scale it

JGXD_Neg                ld a,36                         ;

JGXSD_Okay              ld h,a                          ;
                        ld l,0                          ;
                        srl h                           ;
                        rr l                            ;
                        ld (DispTargX16),hl             ;

                        ld a,(ManAngle)                 ; Which way are we facing?
                        ld h,[AngleOffsetYNeg] 0        ; Assume Up

                        cp 0                            ; Up?
                        jr z JustGotYDisp               ; Yep, skip

                        ld h,[AngleOffsetY] 0           ; Assume down

                        cp 2                            ; Down?
                        jr z JustGotYDisp               ;

                        ld a,[JustYDisp]0               ; Get the last offset
                        ld h,a                          ;

JustGotYDisp            ld a,h                          ; Get it
                        ld (JustYDisp),a                ; Save it

                        ; Offset the target position

                        add a,d                         ;

                        ; Positive, but clip to a reasonable range

                        cp 12                           ;
                        jr c JGYD_Neg                   ;

                        cp $C0                          ;
                        jr nc JGYD_Neg                  ;

                        cp 100                          ;
                        jr c JGYSD_Okay                 ;

                        ld a,100                        ;
                        jr JGYSD_Okay                   ;

                        ; Scale it

JGYD_Neg                ld a,12                         ;

JGYSD_Okay              ld h,a                          ;
                        ld l,0                          ;
                        srl h                           ;
                        rr l                            ;
                        ld (DispTargY16),hl             ;

                        ret                             ; Done

; Float the viewport to this position

TendTowardsDisplayPos   ld hl,(DispTargX16)             ;
                        ld de,(DispCurrX16)             ;
                        call TendTowards                ;
                        ld (DispCurrX16),hl             ;

                        ld hl,(DispTargY16)             ;
                        ld de,(DispCurrY16)             ;
                        call TendTowards                ;
                        ld (DispCurrY16),hl             ;
                        ret                             ; Done

; Tend towards

TendTowards             or a                            ;
                        sbc hl,de                       ; HL:=difference

                        ld a,(ScrollType)               ;
                        ld b,a                          ;

TT_Lp                   sra h                           ;
                        rr l                            ;

                        djnz TT_Lp                      ;

                        add hl,de                       ;
                        ret                             ;

WriteDE_A_80            loop 80                         ;
                          ld (de),a                     ;
                          inc de                        ;
                          lend                          ;
                        ret                             ;

CopyHLDE_80             loop 80                         ;
                          ldi                           ;
                          lend                          ;
                        ret                             ;

; Data

SwdUpTab                defb $00,$00,$E5                ;
                        defb $FF,$FF,$E6                ;
                        defb $00,$00,$E5                ;
                        defb $01,$00,$E4                ;
                        defb $00,$00,$E5                ;
                        defb $FF,$FF,$E6                ;
                        defb $00,$00,$E5                ;
                        defb $01,$00,$E4                ;
                        defb $00,$00,$E5                ;
                        defb 0,0,0,0,0                  ;

                        defb $00,$00,$E4                ;
                        defb $80,$00,$E7                ;
                        defb $80,$00,$E6                ;
                        defb $80,$00,$E7                ;
                        defb $00,$00,$E4                ;
                        defb $80,$00,$E7                ;
                        defb $80,$00,$E6                ;
                        defb $80,$00,$E7                ;
                        defb $00,$00,$E4                ;
                        defb 0,0,0,0,0                  ;

                        defb $00,$00,$E5                ;
                        defb $FF,$FF,$E4                ;
                        defb $00,$00,$E5                ;
                        defb $01,$00,$E6                ;
                        defb $00,$00,$E5                ;
                        defb $FF,$FF,$E4                ;
                        defb $00,$00,$E5                ;
                        defb $01,$00,$E6                ;
                        defb $00,$00,$E5                ;
                        defb 0,0,0,0,0                  ;

                        defb $00,$00,$E6                ;
                        defb $80,$00,$E7                ;
                        defb $80,$00,$E4                ;
                        defb $80,$00,$E7                ;
                        defb $00,$00,$E6                ;
                        defb $80,$00,$E7                ;
                        defb $80,$00,$E4                ;
                        defb $80,$00,$E7                ;
                        defb $00,$00,$E6                ;

WallDefs                defb $9C,$9C,$9C,$9C,$9C,$9C,0,0;
                        defb $98,$DD,$DD,$DD,$DD,$94,0,0;
                        defb $98,$20,$20,$20,$20,$94,0,0;
                        defb $20,$20,$20,$20,$20,$20,0,0;
                        defb $93,$93,$93,$93,$93,$93,0,0;
                        defb $92,$DC,$DC,$DC,$DC,$91,0,0;
                        defb $92,$20,$20,$20,$20,$91,0,0;
                        defb $20,$20,$20,$20,$20,$20,0,0;

; First we have the base value

MonsterTypes            defb 0,0                        ; pMaze
                        defb $D0                        ; Char
                        defb 0                          ; MoveType
                        defb 100                        ; Strength
                        defb 0                          ; Flags
                        defb 16                         ; Magic
                        defb 32                         ; MaxMagic
                        defb 0                          ; Treasure
                        defb 0                          ; MaxTreasure
                        defb 60                         ; Delay
                        defb 60                         ; iDelay
                        defb 4                          ; nArrows
                        defb 30                         ; Wounds
                        defb 0                          ; Combat
                        defb 0                          ; Direction
                        defb 0,0,0,0                    ; Cache

; Then we have the range of variation allowed for each byte

                        defb 0,0                        ; pMaze
                        defb 8                          ; Char
                        defb 6                          ; MoveType  0 .. 5
                        defb 20                         ; Strength
                        defb 0                          ; Flags
                        defb 8                          ; Magic
                        defb 16                         ; MaxMagic
                        defb 0                          ; Treasure
                        defb 0                          ; MaxTreasure
                        defb 0                          ; Delay
                        defb 90                         ; iDelay
                        defb 3                          ; nArrows
                        defb 20                         ; Wounds
                        defb 0                          ; Combat
                        defb 0                          ; Direction
                        defb 0,0,0,0                    ; Cache

        ; Make sure it's sensible

        if (( *-MonsterTypes)/2 ) <> lMonsterFixed      ;
                        zeuserror "Error in definition" ;
        endif                                           ;

; Stuff shown in maze

SMess                   db "Halls Of   "                ;
                        db "The Things "                ;
                        db "           "                ;
                        db "1983..2019 "                ;
                        db "           "                ;
                        db "Things     "                ;
                        db "trained by "                ;
                        db "           "                ;
                        db "Martin     "                ;
                        db "Horsley    "                ;
                        db "           "                ;
                        db "Neil       "                ;
                        db "Mottershead"                ;
                        db "           "                ;
                        db "Simon      "                ;
                        db "Brattel    "                ;

; Maze type probabilities

ConTab                  defb 0,255,200,150,127,100, 60, 20;
                        defb 0,150,100, 40, 23, 13, 7, 4;
                        defb 0,200,100, 50, 30, 20, 10, 5;

; Variables from here on.

Vars_Start              equ *                           ;

        if def bMyDefaults                              ;
GameCount               db JokeDelay-1                  ;
bJokeEnable             db $FF                          ;
        else                                            ;
GameCount               db 0                            ;
bJokeEnable             db 0                            ; Turned OFF by default
        endif                                           ;

EndOfBlock0000          equ *                           ;

; Game options

AType                   ds 1                            ;
BType                   ds 1                            ;
CType                   ds 1                            ;
DType                   ds 1                            ;
ScrollType              ds 1                            ;
LookAheadType           ds 1                            ;

; Define the positions of the rings

MazeList                ds 8*512                        ;

; The monsters

MonsterList             ds nMonst * lMonst              ;

; The end of used space

Vars_End                equ *                           ;

                        org $BFBF                       ;
                        disp 0                          ;

                        push ix                         ;
                        push hl                         ;
                        push de                         ;
                        push bc                         ;
                        push af                         ;

                        ; Calculate the display's target position

                        ld a,[bTileMode]0               ; Showing tiles
                        or a                            ;
                        jr z Irq_ND                     ; Nope

                        call CalcDisplayTargetPos       ;

                        ; Tend the display position towards the target position

                        call TendTowardsDisplayPos      ;

                        ; Now redraw the display at the target position

                        call RedrawDisplay              ; Draw it

                        ; And update the offset registers

Irq_ND                  ld a,(ManLightDel)              ;
                        or a                            ;
                        jp z Irq_1                      ;

                        dec a                           ;
                        ld (ManLightDel),a              ;

Irq_1                   ld a,1                          ;
                        ld (IrqFlag),a                  ;

                        ld a,(MManDelay)                ;
                        dec a                           ;
                        ld (MManDelay),a                ;

                        call GameScanKeys               ;

;                        call BootTest                   ;

                        pop af                          ;
                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        pop ix                          ;
                        ei                              ;
                        ret                             ;

; We're going to put the following data at known locations

                        org $C000                       ;

                        ; This MUST be placed at $C000 - for speed some of the code relies on it

BigMazeSize             equ (7*16+1)*128                ;

BigMaze                 ds BigMazeSize,0                ;
TopLeftSanc             equ BigMaze+113                 ;

                        ; F880

; Key flags                                             ;

KeyStart                equ *                           ;
KeyFire                 ds 1                            ;
KeyFireP                ds 1                            ;
KeyArrow                ds 1                            ;
KeyArrowP               ds 1                            ;
KeyLight                ds 1                            ;
KeyLightP               ds 1                            ;
KeyDrop                 ds 1                            ;
KeyDropP                ds 1                            ;
KeyClose                ds 1                            ;
KeyCloseP               ds 1                            ;
KeySword                ds 1                            ;
KeySwordP               ds 1                            ;
KeyPortal               ds 1                            ;
KeyPortalP              ds 1                            ;

Keysp                   ds 1                            ;
KeyspP                  ds 1                            ;
Key1                    ds 1                            ;
Key1P                   ds 1                            ;
Key2                    ds 1                            ;
Key2P                   ds 1                            ;
KeyFlag                 ds 1                            ;
KeyEnd                  equ *                           ;

SwagBag                 ds MaxTreasure                  ;
JFLAG                   ds 1                            ;

DummyByte               ds 1                            ;

                        align 256                       ;
IntPage                 ds $101                         ;

; Misc variables

pFrameX                 ds 1                            ; Must be together!
pFrameY                 ds 1                            ; Must be together!

Seed                    ds 4                            ;
MoveList                ds 4                            ;

; Score vars

; Irq

VarPalette              ds 32                           ; A buffer

Ye_End                  equ *                           ;

; The rings

RingTab                 ds lRingTable*8,0               ;

; The projectiles

ProjList                ds nProj * lProj                ;

                        zeusassert * < $FF00,"Out of resources";


                        org $FF00                       ; Last page
StackTop                equ *                           ; Top of memory

; The small maze, one byte per room. Needs to be aligned on a page

Maze                    defs $100                       ;

; We want to tell the emulator about the writeable sections

                        mem_var Vars_Start,Vars_End-Vars_Start ; Game variables
                        mem_var BigMaze,$10000-BigMaze  ; We can write this

; This command tells Zeus where to put the code it generates. As a nex file...
; Alter the path to suit your system

                        output_nex "hott.nex",$0000,Start,"3.0.04" ; nex file
//                        output_con "hott.con",$0000,Start,"2.0.27" ; zcf file
;                        output_nex "Q:\\\\hott.nex",$0000,Start,"2.0.27" ; nex file

//                        output_nex_data "hott.nex",dl nexextra, df "chars.inc"
//                        output_nex_data "hott.nex", df "chars.inc"

//nexextra equ output_nex_data("hott.nex")

//                      output_nex_data "hott.nex",2    ;
//                      output_nex_data "hott.nex",df "chars.inc","Hello";


;                        output_nex "C:\\temp\\NexCreator-master\\sd\\NexTest.nex",$0000,Start,"2.0.27" ; nex file

                        output_para $6000,$6000,Start   ;
                        output_para zeuspage(1), EndOfBlock0000;
                        zeusprinthex zeuspage(1), EndOfBlock0000;

;                        zeusinvoke "C:\\temp\\NexCreator-master\\build\\CSpect.bat","",false

; Detect and report potential problems

FreeSpace               equ StackTop - Ye_End           ; Free(ish) room

        if FreeSpace < 50                               ;
                        zeusprint "WARNING! Stack space is low!! = ",FreeSpace," bytes";
        else                                            ;
                        zeusprint "Stack space = ",FreeSpace;
        endif                                           ;

; Warn if there are any strange options set

        if enabled bMyDefaults                          ;
                        zeusprint "Warning! My Defaults!";
        endif                                           ;

        if enabled bFixedMaze                           ;
                        zeusprint "WARNING! Fixed maze!";
        endif                                           ;

        if enabled bNoDamage                            ;
                        zeusprint "WARNING! No Damage!" ;
        endif                                           ;



